//%SF_HEAD_BGN
//==============================================================================
//\[X́FCBtnSetDlg
//\[XF{^o^_CAONX
//쐬NF2000/11/29
//쐬Җ  FMacBS
//l      F
//==============================================================================
//%SF_HEAD_END

#include "stdafx.h"
#include <io.h>
#include "Resource.h"
#include "Comfunc.h"
#include "ExecRun.h"
#include "IconButton.h"
#include "ExecDlg.h"
#include "BtnSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBtnSetDlg _CAO


//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::CBtnSetDlg
//\bhFRXgN^
//`    F  CBtnSetDlg::CBtnSetDlg(
//@@@@@@@F    [in]  CWnd* pParent  F eEBhENXւ̃|C^
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        FCDialogNXƂ
//------------------------------------------------------------------------------
//%ME_HEAD_END
CBtnSetDlg::CBtnSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBtnSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBtnSetDlg)
	m_bIcon = FALSE;
	m_csFileName = _T("");
	m_csIconName = _T("");
	m_csTitle = _T("");
	m_csOption = _T("");
	m_iShowFlag = -1;
	//}}AFX_DATA_INIT
}


void CBtnSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBtnSetDlg)
	DDX_Control(pDX, IDC_ICONFILENAME, m_IconNameEdit);
	DDX_Control(pDX, IDC_ICTITLE, m_cTitleEdit);
	DDX_Control(pDX, IDC_ICONPATH, m_IconRefBtn);
	DDX_Control(pDX, IDC_ICONLIST, m_CListCtrl);
	DDX_Control(pDX, IDC_EXEFILENAME, m_ExeFile);
	DDX_Control(pDX, IDC_ICONCHECK, m_IconChk);
	DDX_Check(pDX, IDC_ICONCHECK, m_bIcon);
	DDX_Text(pDX, IDC_EXEFILENAME, m_csFileName);
	DDX_Text(pDX, IDC_ICONFILENAME, m_csIconName);
	DDX_Text(pDX, IDC_ICTITLE, m_csTitle);
	DDX_Text(pDX, IDC_SETOPTION, m_csOption);
	DDX_CBIndex(pDX, IDC_COMBO1, m_iShowFlag);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBtnSetDlg, CDialog)
	//{{AFX_MSG_MAP(CBtnSetDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ICONLIST, OnItemchangedIconlist)
	ON_EN_KILLFOCUS(IDC_EXEFILENAME, OnKillfocusExefilename)
	ON_BN_CLICKED(IDC_EXEPATH, OnExepath)
	ON_BN_CLICKED(IDC_ICONPATH, OnIconpath)
	ON_BN_CLICKED(IDC_ICONCHECK, OnIconcheck)
	ON_EN_KILLFOCUS(IDC_ICONFILENAME, OnKillfocusIconfilename)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBtnSetDlg bZ[W nh

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnInitDialog
//\bhF_CAÕCxgnh
//`    F  BOOL CBtnSetDlg::OnInitDialog(
//              F  )
//^[l  FTRUE, sFALSE
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
BOOL CBtnSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//C[WXg̍쐬

	int iRet = 0 ;

	if ( m_CImageList.Create( EX_IMAGE_XSIZE, EX_IMAGE_YSIZE, ILC_COLOR16, 0, EX_IMAGENUM ) == 0 ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return TRUE ;
	}
	m_CImageList.SetBkColor( 0x00ffffff );

	//ACR֘AĩANeBuݒ
	if ( m_bIcon == TRUE ) {
		m_IconNameEdit.EnableWindow( TRUE ) ;	
		m_IconRefBtn.EnableWindow( TRUE ) ;	
	}
	else {
		UpdateData( TRUE ) ;
		m_IconNameEdit.EnableWindow( FALSE ) ;	
		m_IconRefBtn.EnableWindow( FALSE ) ;
	}

	//ACRXg̐ݒ
	iRet = SetIconList() ;
	if ( iRet < 0 ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return TRUE ; 
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnItemchangedIconlist
//\bhFACRXg̍쐬
//`    F  void CBtnSetDlg::OnInitDialog(
//@@@@@@@F    [in]  NMHDR* pNMHDR     : NMHDR \
//@@@@@@@F    [out] LRESULT* pResult  : Callback֐̖߂l
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnItemchangedIconlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	HICON hIcon = NULL ;
	CStatic* CIconPtr ;
	int iItem;
	CString csTemp ;
	char cTemp[FILELEN] ;
	struct _stat buf ;					//t@C݃`FbNp
	int iRet = 0 ;

	TRY {
		memset( cTemp, 0x00, sizeof(cTemp) ) ;

		//ACRt@C璼ڗꍇ̃`FbN
		csTemp = m_csIconName;
		UpdateData( TRUE ) ;
		if ( csTemp.CompareNoCase( m_csIconName ) != 0 ) {
			m_iItem = 0 ;
			iRet = SetIconList() ;
			if ( iRet < 0 ) {
				PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
				return ; 
			}
			UpdateData( TRUE ) ;
		}

		//t@C͂璼ڗꍇ̃`FbN
		UpdateData( TRUE ) ;
		if ( m_bIcon == FALSE ) {
			if ( m_csFileName.CompareNoCase( m_csIconName ) != 0 ) {
				UpdateData( TRUE ) ;
				iRet = AutoSetIconName() ;
				if ( iRet == 1 ) {
					iRet = SetIconList();
					if ( iRet < 0 ) {
						PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
						return ;
					}
				}
				else if ( iRet < 0 ) {
					PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
					return ; 
				}
			}
		}

		UpdateData( TRUE ) ;

		//IACRԍ̎擾
		iItem = m_CListCtrl.GetNextItem( -1, LVNI_ALL | LVNI_SELECTED ) ;

		if ( iItem >= 0 ) {
			//ACRԍ̕ۊ
			m_iItem = iItem ;
			//IACR̕\
			CIconPtr = (CStatic*)GetDlgItem(IDC_STATICON) ;
			if ( CIconPtr != NULL ) {
				//ϐ̒u
				dReplaceEnvParam( cTemp, m_csIconName.GetBuffer(m_csIconName.GetLength()) );
				m_csIconName.ReleaseBuffer();
				if ( strlen(cTemp) != 0 ) {
					//t@C̑݃`FbN
					int iRet;
					iRet = _mbstat( cTemp, &buf );
					if ( iRet == 0 ) {
						hIcon = ::ExtractIcon( AfxGetInstanceHandle(), cTemp, m_iItem );
						if ( hIcon != NULL ) {
							//X^eBbNACRL
							CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
							CIconPtr->SetIcon( hIcon ) ;
						}
						else {
							//X^eBbNACRL
							CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
							CIconPtr->SetIcon( AfxGetApp()->LoadIcon( IDI_DEFICON ) );
						}
					}
					else if ( iRet == 1 ) {
						//X^eBbNACRL
						CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
						CIconPtr->SetIcon( AfxGetApp()->LoadIcon( IDI_WEBICON ) );
					}
					else {
						CIconPtr->SetIcon( NULL ) ;
						//X^eBbNACR𖳌
						CIconPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
					}
				}
				else {
					CIconPtr->SetIcon( NULL ) ;
					//X^eBbNACR𖳌
					CIconPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
				}
			}
			else {
			}
		}
	}
	CATCH( CMemoryException, e ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return ; 
	} END_CATCH

	*pResult = 0;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnOK
//\bhFOK{^̃Cxgnh
//`    F  void CBtnSetDlg::OnOK(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnOK() 
{
	CString csTemp;
	int iRet = 0 ;

	TRY {
		//ACRt@C璼ڗꍇ̃`FbN
		csTemp = m_csIconName;
		UpdateData( TRUE );
		if ( csTemp.CompareNoCase( m_csIconName ) != 0 ) {
			m_iItem = 0;
			//ACRXg̐ݒ
			iRet = SetIconList();
			if ( iRet < 0 ) {
				PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
				return;
			}
			UpdateData( TRUE );
		}

		//t@C͂璼ڗꍇ̃`FbN
		UpdateData( TRUE );
		if ( m_bIcon == FALSE ) {
			if ( m_csFileName.CompareNoCase( m_csIconName ) != 0 ) {
				UpdateData( TRUE ) ;
				//ACRt@C̎ݒ
				iRet = AutoSetIconName() ; 
				if ( iRet == 1 ) {
					//ACRXg̐ݒ
					iRet = SetIconList() ;
					if ( iRet < 0 ) {
						PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
						return ; 
					}
					UpdateData( TRUE ) ;
				}
				else if( iRet < 0 ) {
					PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
					return ; 
				}
			}
		}

		//t@Cw`FbN
		m_csFileName.TrimLeft();
		m_csFileName.TrimRight();
		if ( m_csFileName.GetLength() == 0 ) {
			//G[
			MessageBox( ERR_EXEC_MSG05, ERR_EXEC_TITLE01, MB_ICONEXCLAMATION | MB_OK );
			return;
		}
	}
	CATCH( CMemoryException, e ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return ; 
	} END_CATCH

	CDialog::OnOK() ;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnCancel
//\bhFLZ̃Cxgnh
//`    F  void CBtnSetDlg::OnCancel(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnCancel() 
{
	CDialog::OnCancel();
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnKillfocusExefilename
//\bhFExefilenameRg[̓tH[JX
//`    F  void CBtnSetDlg::OnKillfocusExefilename(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnKillfocusExefilename() 
{
	int iRet = 0 ;

	UpdateData( TRUE );
	if ( m_bIcon == FALSE ) {
		if ( m_csFileName.CompareNoCase( m_csIconName ) != 0 ) {
			UpdateData( TRUE );
			//ACRt@C̎ݒ
			iRet = AutoSetIconName();
			if ( iRet == 1 ) {
				//ACRXg̐ݒ
				iRet = SetIconList() ;
				if ( iRet < 0 ) {
					PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
					return;
				}
				UpdateData( TRUE ) ;
			}
			else if ( iRet < 0 ) {
				PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
				return;
			}
		}
	}

}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnExepath
//\bhFst@C̃t@C_CAO
//`    F  void CBtnSetDlg::OnExepath(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnExepath() 
{
	int iRet = 0;
	int iRet2 = 0;
	int iDlgErr = 0;
//	int i;
	CString csPathName;
	CString csTitle;
	CString csOrgPathName;
	CString csOrgTitle;
	CString csAutoTitle;
	BOOL bKanji = FALSE;
	char cTemp[256];
	CString csFilter;

	csFilter  = FILE_FILTER_EXE;
	csFilter += FILE_FILTER_BAT;
	csFilter += FILE_FILTER_ALL;
	csFilter += FILE_FILTER_END;

	//Iłt@C̃tB^[
	CFileDialog FileExecDlg ( TRUE, "EXE", "*.EXE", OFN_FILEMUSTEXIST |OFN_HIDEREADONLY, csFilter, this);

	TRY {

		CString csRunFileName;
		char cPath[FILELEN];
		int iRet;
		struct _stat buf;

		m_ExeFile.GetWindowText( csRunFileName );
		//ϐ̒u
		dReplaceEnvParam( cTemp, csRunFileName.GetBuffer(csRunFileName.GetLength()) );
		csRunFileName.ReleaseBuffer();
		if ( strlen(cTemp) != 0 ) {
			iRet = _mbstat( cTemp, &buf );
			if ( iRet == 0 ) {
				splitPath( cPath, cTemp );
				::SetCurrentDirectory( cPath );
				FileExecDlg.m_ofn.lpstrInitialDir = cPath;
			}
		}

		FileExecDlg.m_ofn.lpstrTitle = EXEC_RUNFILETITLE;
		//_CAO\
		if( FileExecDlg.DoModal() == IDOK ) {
			UpdateData( TRUE );
			//̃^CgEt@CҔ
			m_ExeFile.GetWindowText( csOrgPathName );
			m_cTitleEdit.GetWindowText( csOrgTitle );
			csOrgPathName.TrimLeft();
			csOrgPathName.TrimRight();
			csOrgTitle.TrimLeft();
			csOrgTitle.TrimRight();
			//̃t@Cɑ^Cg擾
			iRet = csOrgPathName.ReverseFind( _T('\\') );
			iRet2 = csOrgPathName.ReverseFind( _T('.') );
			if ( iRet != -1 ) {
				if ( iRet2 != -1 && iRet2 > iRet ) {
					csTitle = _T(csOrgPathName.Mid(iRet + 1, iRet2 - iRet - 1));
				}
				else {
					csTitle = _T(csOrgPathName.Mid(iRet + 1));
				}
				strcpy( cTemp, _T(csTitle.GetBuffer(csTitle.GetLength())) );
				csTitle.ReleaseBuffer();
//Update Start v0.20
//				for ( bKanji = FALSE, i = 0; i < EXEC_TITLE_MAX; i++ ) {
//					//擪R[h
//					if ( bKanji == FALSE ) {
//						if ( IsKanji_SJIS((unsigned char)(*(cTemp + i))) ) {
//							bKanji = TRUE;
//						}
//						else {
//							bKanji = FALSE;
//						}
//					}
//					else {
//						bKanji = FALSE;
//					}
//				}
//				if ( bKanji == FALSE ) {
//					csAutoTitle = csTitle.Left(EXEC_TITLE_MAX);
//				}
//				else {
//					csAutoTitle = csTitle.Left(EXEC_TITLE_MAX-1);
//				}
				csAutoTitle = csTitle;
//Update End   v0.20
			}
			else {
				csAutoTitle = _T("");
			}
			//st@C̐ݒ
			csPathName = _T(FileExecDlg.GetPathName());
			m_ExeFile.SetWindowText( csPathName );
			//ݒ肳ꂽ^Cg͋Ȃ玩XV
			if ( csOrgTitle.GetLength() == 0 || csOrgTitle == csAutoTitle ) {
				//^Cg̐ݒ
				iRet = csPathName.ReverseFind( _T('\\') );
				iRet2 = csPathName.ReverseFind( _T('.') );
				if ( iRet != -1 ) {
					if ( iRet2 != -1 && iRet2 > iRet ) {
						csTitle = _T(csPathName.Mid(iRet + 1, iRet2 - iRet - 1));
					}
					else {
						csTitle = _T(csPathName.Mid(iRet + 1));
					}
					strcpy( cTemp, _T(csTitle.GetBuffer(csTitle.GetLength())) );
					csTitle.ReleaseBuffer();
					m_cTitleEdit.SetWindowText( _T(csTitle) );
				}
			}

			if ( m_bIcon == FALSE ) {
				UpdateData( TRUE );
				m_iItem = 0;
				//ACRt@C̎ݒ
				iRet = AutoSetIconName();
				if ( iRet == 1 ) {
					//ACRXg̐ݒ
					iRet = SetIconList();
					if ( iRet < 0 ) {
						PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
						return;
					}
					UpdateData( TRUE );
				}
				else if ( iRet < 0 ) {
					PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
					return;
				}
			}
			UpdateData( TRUE ) ;
		}

	}
	CATCH( CMemoryException, e ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return ;
	} END_CATCH

}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnIconpath
//\bhFACRt@C̃t@C_CAO
//`    F  void CBtnSetDlg::OnIconpath(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnIconpath() 
{
	int iRet = 0 ;
	int iDlgErr = 0 ;
	CString csPathName ;
	CString csFilter;

	csFilter  = FILE_FILTER_EXE;
	csFilter += FILE_FILTER_ICO;
	csFilter += FILE_FILTER_ALL;
	csFilter += FILE_FILTER_END;

	//Iłt@C̃tB^[
	CFileDialog FileExecDlg ( TRUE, "EXE", "*.EXE", OFN_FILEMUSTEXIST |OFN_HIDEREADONLY, csFilter, this );

	TRY {

		CString csRunFileName;
		char cPath[FILELEN];
		int iRet;
		struct _stat buf;
		char cTemp[FILELEN];

		m_IconNameEdit.GetWindowText( csRunFileName );
		//ϐ̒u
		dReplaceEnvParam( cTemp, csRunFileName.GetBuffer(csRunFileName.GetLength()) );
		csRunFileName.ReleaseBuffer();
		if ( strlen(cTemp) != 0 ) {
			iRet = _mbstat( cTemp, &buf );
			if ( iRet == 0 ) {
				splitPath( cPath, cTemp );
				::SetCurrentDirectory( cPath );
				FileExecDlg.m_ofn.lpstrInitialDir = cPath;
			}
		}

		FileExecDlg.m_ofn.lpstrTitle = EXEC_ICONFILETITLE  ; 
		//_CAO\
		if( FileExecDlg.DoModal() == IDOK ) {
			UpdateData( TRUE );
			csPathName = FileExecDlg.GetPathName();
			m_IconNameEdit.SetWindowText( csPathName );
			m_iItem = 0;
			UpdateData( TRUE );
			iRet = SetIconList();
			if ( iRet < 0 ) {
				PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
				return;
			}
			UpdateData( TRUE );
		}
	}
	CATCH( CMemoryException, e ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return ;
	} END_CATCH

}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnIconcheck
//\bhFACRt@C̓ǂݍ݃tO̐ݒ
//`    F  void CBtnSetDlg::OnIconcheck(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnIconcheck() 
{
	int iRet = 0 ;

	UpdateData( TRUE );

	if ( m_bIcon == TRUE ) {
		m_IconNameEdit.EnableWindow( TRUE ) ;
		m_IconRefBtn.EnableWindow( TRUE ) ;	
	}
	else {
		UpdateData( TRUE ) ;
		//ACRt@C̎ݒ
		iRet = AutoSetIconName() ;
		if ( iRet < 0 ) {
			PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
			return ;
		}
		m_IconNameEdit.EnableWindow( FALSE ) ;
		m_IconRefBtn.EnableWindow( FALSE ) ;
	}

	iRet = SetIconList() ;
	if ( iRet < 0 ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return ;
	}
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::OnKillfocusIconfilename
//\bhFIconfilenameRg[̓tH[JX
//`    F  void CBtnSetDlg::OnKillfocusIconfilename(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CBtnSetDlg::OnKillfocusIconfilename() 
{
	CString csTemp;
	int iRet = 0 ;

	TRY {
		csTemp = m_csIconName ;
		UpdateData( TRUE ) ;
		if ( csTemp.CompareNoCase( m_csIconName ) != 0 ) {
			m_iItem = 0 ;
			iRet = SetIconList() ;
			if ( iRet < 0 ) {
				PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
				return ;
			}
			UpdateData( TRUE ) ;
		}
	}
	CATCH( CMemoryException, e ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return ;
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::SetIconList
//\bhFACRXg̐ݒ
//`    F  int CBtnSetDlg::SetIconList(
//              F  )
//^[l  FO, |PFs
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CBtnSetDlg::SetIconList( void )
{
	HICON hIcon = NULL ;
	long lCount = 0 ;
	long lLoop = 0 ;
	LV_COLUMN lvColumn ;
	LV_ITEM lvItem ;
	int i = 0 ;
	POINT pPoint ;
	CStatic* CIconPtr ;
	char cTemp[FILELEN] ;
	struct _stat buf ;				//t@C݃`FbNp
	int iRet;

	memset( cTemp, 0x00, sizeof(cTemp) ) ;

	UpdateData( TRUE );

	//IACR\pX^eBbNĩ|C^擾
	CIconPtr = (CStatic*)GetDlgItem(IDC_STATICON) ;
	if ( CIconPtr == NULL ) {
		return ( -1 );
	}

	//C[WXg̓eU폜
	lCount = (long)m_CImageList.GetImageCount() ;
	for ( lLoop = lCount; lLoop > 0; lLoop-- ) {
		m_CImageList.Remove( lLoop - 1 );
	}

	//Xg̃ACeUׂč폜
	m_CListCtrl.DeleteAllItems();

	//ϐ̒u
	dReplaceEnvParam( cTemp, m_csIconName.GetBuffer(m_csIconName.GetLength()) );
	m_csIconName.ReleaseBuffer();

	iRet = _mbstat( cTemp, &buf );

	if ( strlen( cTemp ) != 0 ) {
		//t@C̑݃`FbN
		if ( iRet == -1 ) {
			m_iItem = 0 ;
			CIconPtr->SetIcon( NULL ) ;
			//X^eBbNACR𖳌
			CIconPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
			UpdateData( TRUE ) ;
			return( 0 ) ;
		}
	}
	else {
		m_iItem = 0 ;
		CIconPtr->SetIcon( NULL ) ;
		//X^eBbNACR𖳌
		CIconPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
		UpdateData( TRUE ) ;
		return( 0 ) ;
	}

	//C[WXg̐ݒ
	lCount = (long)::ExtractIcon( AfxGetInstanceHandle(), cTemp, (UINT)(-1) );
	if ( lCount <= 0 ) {
		m_iItem = 0;
		lCount = 1;
		if ( iRet == 1 ) {
			m_CImageList.Add( AfxGetApp()->LoadIcon( IDI_WEBICON ) );
		}
		else {
			m_CImageList.Add( AfxGetApp()->LoadIcon( IDI_DEFICON ) );
		}
	}
	else {
		//Xgւ̃ACeǉ
		for ( lLoop = 0; lLoop < lCount; lLoop++ ) {
			hIcon = ::ExtractIcon( AfxGetInstanceHandle(), cTemp, lLoop );
			if ( hIcon != NULL ) {
				if ( m_CImageList.Add(hIcon) < 0 ) {
					break ;
				}
			}
			else {
				break ;
			}
		}
	}

	//C[WXg̐ݒ
	m_CListCtrl.SetImageList( &m_CImageList, LVSIL_NORMAL );

	lvColumn.mask = LVCF_FMT;
	lvColumn.fmt = LVCFMT_LEFT;
	m_CListCtrl.InsertColumn( 0, &lvColumn );

	pPoint.x = EX_SETIMAGE_PX;
	pPoint.y = EX_SETIMAGE_PY;

	for ( i = 0; i < lCount; i++ ) {
		m_CListCtrl.InsertItem( i, LPSTR_TEXTCALLBACK, i );
		m_CListCtrl.SetItemPosition( i, pPoint );
		pPoint.x += EX_IMAGE_XSIZE + 2;
	}

	//XN[o[[
	pPoint.x = m_CListCtrl.GetScrollPos( SB_HORZ );
	m_CListCtrl.Scroll( CSize(pPoint.x * (-1), 0) );

	//IACR̐ݒ
	if ( lCount > 0 && m_iItem >= 0 ) {
		lvItem.mask = LVIF_STATE;
		lvItem.iItem = m_iItem;
		lvItem.iSubItem = 0;
		lvItem.state = LVIS_SELECTED | LVIS_FOCUSED;
		lvItem.stateMask = LVIS_SELECTED | LVIS_FOCUSED;
		m_CListCtrl.SetItem( &lvItem );
	}

	if ( m_iItem >= 0 ) {
		//ϐ̒u
		dReplaceEnvParam( cTemp, m_csIconName.GetBuffer(m_csIconName.GetLength()) );
		m_csIconName.ReleaseBuffer();

		//t@C̑݃`FbN
		int iRet;
		iRet = _mbstat( cTemp, &buf );
		if ( iRet == 0 ) {
			lCount = (long)::ExtractIcon( AfxGetInstanceHandle(), cTemp, (UINT)(-1) );
			if ( lCount <= 0 ) {
				//X^eBbNACRL
				CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
				CIconPtr->SetIcon( AfxGetApp()->LoadIcon( IDI_DEFICON ) );
			}
			else {
				hIcon = ::ExtractIcon( AfxGetInstanceHandle(), cTemp, m_iItem );
				if ( hIcon != NULL ) {
					//X^eBbNACRL
					CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
					CIconPtr->SetIcon( hIcon );
				}
				else {
					//X^eBbNACRL
					CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
					CIconPtr->SetIcon( AfxGetApp()->LoadIcon( IDI_DEFICON ) );
				}
			}
		}
		else if ( iRet == 1 ) {
			//X^eBbNACRL
			CIconPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
			CIconPtr->SetIcon( AfxGetApp()->LoadIcon( IDI_WEBICON ) );
		}
		else {
			CIconPtr->SetIcon( NULL );
			//X^eBbNACR𖳌
			CIconPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
		}
	}
	else {
		CIconPtr->SetIcon( NULL );
		//X^eBbNACR𖳌
		CIconPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
	}

	return( 0 );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCBtnSetDlg::AutoSetIconName
//\bhFACRt@C̎ݒ
//`    F  int CBtnSetDlg::AutoSetIconName(
//              F  )
//^[l  FO, |PFs
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CBtnSetDlg::AutoSetIconName( void )
{
	char AssociateName[FILELEN] ;	//֘Att@C
	char cTemp[FILELEN] ;
	CString csTemp;
	int iCount;
	struct _stat buf ;					//t@C݃`FbNp

	TRY {
		memset( AssociateName, 0x00, sizeof(AssociateName) );

		//t@CŐ󔒂
		csTemp = m_csFileName;
		csTemp.TrimLeft();
		csTemp.TrimRight();

		//ϐ̒u
		dReplaceEnvParam( cTemp, csTemp.GetBuffer(csTemp.GetLength()) );
		csTemp.ReleaseBuffer();

		//t@C݂邩H
		int iRet;
		iRet = _mbstat( cTemp, &buf );
		if ( iRet == 0 ) {

			csTemp = cTemp;

			//֘Att@C擾
			if ( GetAssociateFileName( AssociateName, cTemp ) < NO_ERR ) {
				PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
				return( -1 );
			}

			//֘At̃t@CƓt@CH
			if ( csTemp.CompareNoCase( AssociateName ) != 0 ) {
				if ( m_csIconName.CompareNoCase( AssociateName ) != 0 ) {
					m_IconNameEdit.SetWindowText( AssociateName );
					m_csIconName = AssociateName;
					iCount = (int)::ExtractIcon( AfxGetInstanceHandle(), AssociateName, (UINT)(-1) );
					if ( iCount <= 0 ) {
						m_iItem = 0;
					}
					else {
						//֘At̃ACRCfbNX擾
						m_iItem = getDefaultIconIndex( cTemp );
						if ( m_iItem < 0 || m_iItem >= iCount ) {
							m_iItem = 1;
						}
					}
					return( 1 );
				}
				else {
					return( 0 );
				}
			}
			else {
				//t@CɎw肳ꂽ̂̂܂ܐݒ
				m_IconNameEdit.SetWindowText( m_csFileName );
				return( 1 );
			}
		}
		else {
			//t@CɎw肳ꂽ̂̂܂ܐݒ
			m_IconNameEdit.SetWindowText( m_csFileName );
			return( 1 );
		}
	}
	CATCH( CMemoryException, e ) {
		PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
		return( -1 );
	} END_CATCH
}
