//%SF_HEAD_BGN
//==============================================================================
//\[X́FComfunc
//\[XFʊ֐Cu
//쐬NF2000/12/01
//쐬Җ  FMacBS
//l      F
//==============================================================================
//%SF_HEAD_END

#include "stdafx.h"
#include "comfunc.h"
#include "ExecRun.h"
#include "winver.h"
#include "winnls.h"
#include <afxdisp.h>

#define IsKanji_SJIS(c) (((c)&0xff) >= 0x81 && ((c)&0xFF) <= 0x9F) || (((c)&0xFF) >= 0xE0 && ((c)&0xFF) <= 0xFD)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FdReplaceEnvParam
//\bhFw蕶̊ϐp[^u
//`    F  int dReplaceEnvParam(
//@@@@@@@F    [out] char* cDestStrlong  : u̕i[̈
//@@@@@@@F    [in]  char* cSrcStr       : uO̕i[̈
//              F  )
//^[l  F0=, 0ȊO=ُ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int dReplaceEnvParam( char* cDestStr, char* cSrcStr )
{
	char* pSearch1;
	char* pSearch2;
	char* pEnv;
	char cTemp[SERVER_FNAME_MAX];
	int iPtr0;
	int iPtr1;
	int iPtr2;

	//̃`FbN
	if ( cSrcStr == NULL ) {
		return(ERR_GENERAL);
	}
	else if ( cDestStr == NULL ) {
		return(ERR_GENERAL);
	}

	strcpy( cDestStr, "" );
	iPtr0 = 0;
	iPtr1 = 0;
	iPtr2 = 0;

	//擪p[^w
	for (;;) {
		pSearch1 = strchr( cSrcStr + iPtr0, ENV_PARAM_STR );
		if ( pSearch1 == NULL ) {
			//c蕶ׂăRs[
			strcat( cDestStr, cSrcStr + iPtr0 );
			//[v𔲂
			break;
		}
		else {
			iPtr1 = (int)(pSearch1 - cSrcStr);
			pSearch2 = strchr( pSearch1 + 1, ENV_PARAM_STR );
			if ( pSearch2 == NULL ) {
				//c蕶ׂăRs[
				strcat( cDestStr, cSrcStr + iPtr0 );
				//[v𔲂
				break;
			}
			else {
				iPtr2 = (int)(pSearch2 - cSrcStr);
				//擪̃p[^܂łRs[
				if ( iPtr1 - iPtr0 > 0 ) {
					memcpy( cTemp, cSrcStr + iPtr0, iPtr1 - iPtr0 );
					*(cTemp + iPtr1 - iPtr0) = '\0';
					strcat( cDestStr, cTemp );
				}
				//ϐ擾
				if ( iPtr2 - iPtr1 - 1 > 0 ) {
					memcpy( cTemp, cSrcStr + iPtr1 + 1, iPtr2 - iPtr1 - 1 );
					*(cTemp + iPtr2 - iPtr1 - 1) = '\0';
					pEnv = getenv(cTemp);
					if ( pEnv != NULL ) {
						strcat( cDestStr, pEnv );
					}
				}
				//|C^XV
				iPtr0 = iPtr2 + 1;
				//I[`FbN
				if ( *(cSrcStr + iPtr0) == '\0' ) {
					break;
				}
			}
		}
	}

	return(NO_ERR);
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FGetAssociateFileName
//\bhF֘Att@C擾
//`    F  int GetAssociateFileName(
//@@@@@@@F    [out] char*  pcAssociateName   : ֘Att@Ci[̈
//@@@@@@@F    [in]  char*  pcFileName        : f[^t@C
//              F  )
//^[l  F0=, 0ȊO=ُ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int GetAssociateFileName( char* pcAssociateName, char* pcFileName )
{
	char AssociateName[FILELEN];	//֘Att@C
	char cTemp[FILELEN];
	char cTemp2[FILELEN];
	char cTemp3[FILELEN];
	CString csTemp;
	int iCount = 0;
	CString csTemp2;
	int iRet = 0;
	int iLen;

	TRY {

		//`FbN
		if ( pcAssociateName == NULL ) {
			return( ERR_GENERAL );
		}
		if ( pcFileName == NULL ) {
			return( ERR_GENERAL );
		}

		//ϐ
		memset( AssociateName, 0x00, sizeof(AssociateName) ) ;
		memset( cTemp, 0x00, sizeof(cTemp) ) ;
		memset( cTemp2, 0x00, sizeof(cTemp2) ) ;
		memset( cTemp3, 0x00, sizeof(cTemp3) ) ;

		//ϐ̒u
		dReplaceEnvParam( cTemp, pcFileName ) ;

		//t@C擾łH
		if ( strlen( cTemp ) > 0 ) {
			//V[gt@CpX
			if ( ::GetShortPathName( cTemp, cTemp2, sizeof(cTemp2)) != 0 ) {
				csTemp = cTemp2;
			}
			else {
				csTemp = cTemp;
			}
			//t@CɊ֘Atꂽs\t@C邩H
			if ( ::FindExecutable( csTemp, NULL, AssociateName ) > (HINSTANCE)32 ) {
				//t@CÓu"v
				iLen = strlen( AssociateName );
				if ( iLen > 0 ) {
					if ( AssociateName[0] == '"' ) {
						strcpy( cTemp3, AssociateName + 1 );
					}
					else {
						strcpy( cTemp3, AssociateName );
					}
					iLen = strlen( cTemp3 );
					if ( iLen > 0 ) {
						if ( cTemp3[iLen-1] == '"' ) {
							cTemp3[iLen-1] = '\0';
						}
					}
					strcpy( AssociateName, cTemp3 );
				}
				//V[gt@CpX
				if ( ::GetShortPathName( AssociateName, cTemp3, sizeof(cTemp3)) != 0 ) {
					memset( AssociateName, 0x00, sizeof(AssociateName) ) ;
					strcpy( AssociateName, cTemp3 ) ;
					//t@C̎擾
					iRet = GetLongPathName( AssociateName, &csTemp2 ) ;
					if ( iRet != 0 ) {
						return( ERR_GENERAL ) ;
					}
					else {
						strcpy( pcAssociateName, csTemp2.GetBuffer( csTemp2.GetLength() ) );
						csTemp2.ReleaseBuffer();
						return( NO_ERR );
					}
				}
				else {
					//擾֘Att@Ĉ܂ܐݒ
					strcpy( pcAssociateName, AssociateName );
					return( NO_ERR );
				}
			}
			else {
				//t@CɎw肳ꂽ̂̂܂ܐݒ
				strcpy( pcAssociateName, pcFileName );
				return( NO_ERR );
			}
		}
		else {
			//t@CɎw肳ꂽ̂̂܂ܐݒ
			strcpy( pcAssociateName, pcFileName );
			return( NO_ERR );
		}
	}
	CATCH( CMemoryException, e ) 
	{
		return( ERR_GENERAL ) ;
	} END_CATCH
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FGetLongPathName
//\bhFOt@C擾
//`    F  int GetAssociateFileName(
//@@@@@@@F    [in]  char* pShortPath      :  V[gpX
//@@@@@@@F    [out] CString* pcsLongPath  :  OpX
//              F  )
//^[l  F0=, 0ȊO=ُ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int GetLongPathName( char* pShortPath, CString* pcsLongPath )
{
	WIN32_FIND_DATA  FindDataSt ;	//WIN32_FIND_DATA\̂ͤꂽt@CLq܂
	HANDLE hFnd ;					//t@Cnh
	char cTemp[FILELEN] ;
	CString csTemp ;
	char cFIleName[FILELEN] ;		//fBNg
	int iStrBuff = 0 ;
	int iGetByteCnt = 0 ;			//擾oCg
	int iFindByte = 0 ;				//oCg
	int iLen = 0 ;					//pX̒
	int iRet = 0 ;
	int iRet2 = 0 ;
	int iCt = 0 ;
	BOOL bRet = 0 ;

	CString csFindStr ;

	TRY {
		memset( &FindDataSt, 0x00, sizeof(WIN32_FIND_DATA) ) ;
		memset( cTemp, 0x00, sizeof(cTemp) ) ;
		memset( cFIleName, 0x00, sizeof(cFIleName) ) ;

		if ( pShortPath == NULL || pcsLongPath == NULL ) {
			return( ERR_GENERAL ) ;
		}
		
		//pX̒擾
		iLen = strlen( pShortPath ) ;
		if ( iLen == 0 ) {
			return( ERR_GENERAL ) ;
		}

		csFindStr = pShortPath ;

		//lbg[NhCuH
		iStrBuff = csFindStr.Find( '\\' );
		if ( iStrBuff == 0 ) {
			//̂܂܃t@CԂ
			*pcsLongPath = csFindStr;
			return( NO_ERR );
		}

		//t@C擾
		iStrBuff = csFindStr.ReverseFind( '\\' );
		iStrBuff = iStrBuff + 1;
		strcpy( cFIleName, _T(csFindStr.Mid( iStrBuff, csFindStr.GetLength())) );

		//hCu
		iGetByteCnt = csFindStr.Find( '\\' );
		*pcsLongPath = csFindStr.Mid( 0, iGetByteCnt+1 );
		//fBNg擾
		csTemp = csFindStr.Mid( iGetByteCnt+1, csFindStr.GetLength()+1 );

		//ŏ̃fBNg擾
		iFindByte = csTemp.Find( '\\' );
		if ( iFindByte == -1 ) {
			//̎o
			csTemp = csTemp.Mid( 0, csFindStr.GetLength() + 1 );
			iGetByteCnt = iLen;
		}
		else {
			//̎o
			csTemp = csTemp.Mid( iFindByte + 1, csFindStr.GetLength() + 1 );
			iGetByteCnt = iGetByteCnt + iFindByte + 1;
		}
		//ŏ猟ʂ܂Ŏ擾
		strcpy( cTemp, _T(csFindStr.Left( iGetByteCnt )) );

		//fBNg擾
		//Ot@Cꌏڎ擾
		hFnd = ::FindFirstFile( cTemp, &FindDataSt );
		if ( hFnd == NULL ) {
			return( ERR_GENERAL );
		}

		if ( hFnd != NULL ) {
			//N[Y
			::FindClose( hFnd );
			hFnd = NULL;
		}

		while( iCt < FILELEN ) {
			//t@CHEłȂH
			iRet = strcmp( FindDataSt.cAlternateFileName, cFIleName );
			iRet2 = strcmp( FindDataSt.cFileName, "" );
			if ( iRet == 0 || iRet2 == 0 ) {
				if ( iRet == 0 ) {
					//efBNg
					*pcsLongPath += FindDataSt.cFileName;
				}
				break;
			}
			else {
				//efBNg
				*pcsLongPath += FindDataSt.cFileName;
				if ( iFindByte < 0 )
					break;
			}
			memset( cTemp, 0x00, sizeof(cTemp) );
			memset( &FindDataSt, 0x00, sizeof(WIN32_FIND_DATA) );

			//̃fBNg
			iFindByte = csTemp.Find( '\\' );
			if ( iFindByte != -1 ) {
				iGetByteCnt = iGetByteCnt + iFindByte + 1;
				//
				csTemp = csTemp.Mid( iFindByte + 1, csFindStr.GetLength() + 1 );
			}
			else {
				iGetByteCnt = iLen;
			}
			//ŏ猟ʂ܂Ŏ擾
			strcpy( cTemp, _T(csFindStr.Left( iGetByteCnt )) );
			//̃fBNg擾	
			hFnd = ::FindFirstFile( cTemp, &FindDataSt );
			if ( hFnd == NULL ) {
				return( ERR_GENERAL );
			}
			//}[N
			*pcsLongPath += "\\";
			iCt++;

			if ( hFnd != NULL ) {
				//N[Y
				::FindClose( hFnd );
				hFnd = NULL;
			}
		}

		if ( hFnd != NULL ) {
			//N[Y
			::FindClose( hFnd );
		}

		return( NO_ERR );

	}
	CATCH( CMemoryException, e ) 
	{
		return( ERR_GENERAL );
	} END_CATCH

}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FdCheckExecFileType
//\bhFEXEt@C̎ʂ`FbN
//`    F  int dCheckExecFileType(
//@@@@@@@F    [in]  char* cFileName  :  `FbNΏEXẼtpXi[̈ւ̃|C^
//              F  )
//^[l  FFTYPE_EXE    :  EXE
//@@@@@@@FFTYPE_DAT    :  f[^t@C
//@@@@@@@FERR_GENERAL  :  t@C݂Ȃ / 擾s
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int dCheckExecFileType( char* cFileName )
{
	CString csEXT;							//t@Cgq`FbN
	CString csFileName;						//t@C
	struct _stat buf;						//t@C݃`FbNp

	if ( cFileName == NULL ) {
		return(ERR_GENERAL);
	}

//Add v0.24
	csFileName = cFileName;
	csEXT = "http:";
	if ( csEXT.Compare( csFileName.Left(5) ) == 0 ) {
		//URLȂURLԂ
		return(FTYPE_URL);
	}
//Add v0.24

	//t@C̑݃`FbN
	if ( _stat( cFileName, &buf ) != 0 ) {
		//t@C݂Ȃ΃G[Ԃ
		return(ERR_GENERAL);
	}

	//EXEԂ
	return(FTYPE_EXE);
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FgetIniFileName
//\bhFInit@C擾
//`    F  void getIniFileName(
//@@@@@@@F    [out] char* cIniFileName F Init@Ci[̈
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void getIniFileName( char* cIniFileName )
{
	char cFullName[EXECFILEMAX];
	char cPathName[EXECFILEMAX];

	::GetModuleFileName( NULL, cFullName, EXECFILEMAX-1 );
	splitPath( cPathName, cFullName );
	strcpy( cIniFileName, cPathName );
	strcat( cIniFileName, "\\" );
	strcat( cIniFileName, EXEC_INIFILENAME );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsplitPath
//\bhFtpXpXo
//`    F  int splitPath(
//@@@@@@@F    [out] char* cPathName F pX
//@@@@@@@F    [in]  char* cFileName F tpX
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int splitPath( char* cPathName, char* cFileName )
{
	char* pPathPtr = NULL;
	int iLen = 0;

	if ( cFileName == NULL ) {
		return(ERR_GENERAL);
	}
	if ( cPathName == NULL ) {
		return(ERR_GENERAL);
	}

	if ( strlen(cFileName) >= SERVER_FNAME_MAX ) {
		return(ERR_GENERAL);
	}

	pPathPtr = strrchr( cFileName, '\\' );
	if ( pPathPtr != NULL ) {
		//\܂܂Ȃ̒Zo
		iLen = pPathPtr - cFileName;
		if ( iLen > 0 ) {
			strncpy( cPathName, cFileName, iLen );
			*(cPathName + iLen) = '\0';
		}
		else {
			*cPathName = '\0';
		}
		return( NO_ERR );
	}
	else {
		return(ERR_GENERAL);
	}
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionSetDlgX
//\bhFݒ_CAO\ʒuXW̕ۑ
//`    F  void saveOptionSetDlgX(
//@@@@@@@F    [in]  long lVal F ݒ_CAO\ʒuXW
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionSetDlgX( long lVal )
{
	if ( lVal == loadOptionSetDlgX() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SetDlgX", lVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionSetDlgY
//\bhFݒ_CAO\ʒuYW̕ۑ
//`    F  void saveOptionSetDlgY(
//@@@@@@@F    [in]  long lVal F ݒ_CAO\ʒuYW
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionSetDlgY( long lVal )
{
	if ( lVal == loadOptionSetDlgY() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SetDlgY", lVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionSearchDlgX
//\bhF_CAO\ʒuXW̕ۑ
//`    F  void saveOptionSearchDlgX(
//@@@@@@@F    [in]  long lVal F ݒ_CAO\ʒuXW
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionSearchDlgX( long lVal )
{
	if ( lVal == loadOptionSearchDlgX() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SearchDlgX", lVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionSearchDlgY
//\bhF_CAO\ʒuYW̕ۑ
//`    F  void saveOptionSearchDlgY(
//@@@@@@@F    [in]  long lVal F ݒ_CAO\ʒuYW
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionSearchDlgY( long lVal )
{
	if ( lVal == loadOptionSearchDlgY() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SearchDlgY", lVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionSetDlgX
//\bhFݒ_CAO\ʒuXW̓Ǎ
//`    F  long loadOptionSetDlgX(
//              F  )
//^[l  Fݒ_CAO\ʒuXW
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC long loadOptionSetDlgX( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "SetDlgX", "400", cProfile );

	return( atol(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionSetDlgY
//\bhFE`_CAO\ʒuYW̓Ǎ
//`    F  long loadOptionSetDlgY(
//              F  )
//^[l  FE`_CAO\ʒuYW
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC long loadOptionSetDlgY( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "SetDlgY", "50", cProfile );

	return( atol(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionSearchDlgX
//\bhF_CAO\ʒuXW̓Ǎ
//`    F  long loadOptionSearchDlgX(
//              F  )
//^[l  F_CAO\ʒuXW
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC long loadOptionSearchDlgX( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "SearchDlgX", "400", cProfile );

	return( atol(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionSearchDlgY
//\bhF_CAO\ʒuYW̓Ǎ
//`    F  long loadOptionSearchDlgY(
//              F  )
//^[l  F_CAO\ʒuYW
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC long loadOptionSearchDlgY( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "SearchDlgY", "50", cProfile );

	return( atol(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionInitDlgDisp
//\bhFE`_CAON\IvVl̓Ǎ
//`    F  long loadOptionInitDlgDisp(
//              F  )
//^[l  FE`_CAON\IvVl
//O        FȂ
//쐬N  F2001/01/25
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int loadOptionInitDlgDisp( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "InitDisp", "0", cProfile );

	return( atoi(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionInitDlgDisp
//\bhFE`_CAON\IvVl̕ۑ
//`    F  void saveOptionInitDlgDisp(
//@@@@@@@F    [in]  long lVal F E`_CAON\IvVl
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2001/01/25
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionInitDlgDisp( int iVal )
{
	if ( iVal == loadOptionInitDlgDisp() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "InitDisp", (long)iVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionMouseHook
//\bhFfXNgbvj[\IvVl̓Ǎ
//`    F  long loadOptionMouseHook(
//              F  )
//^[l  FfXNgbvj[\IvVl
//O        FȂ
//쐬N  F2005/02/17
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int loadOptionMouseHook( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "MouseHook", "1", cProfile );

	return( atoi(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionMouseHook
//\bhFfXNgbvj[\IvVl̕ۑ
//`    F  void saveOptionMouseHook(
//@@@@@@@F    [in]  long lVal F fXNgbvj[\IvVl
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2005/02/17
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionMouseHook( int iVal )
{
	if ( iVal == loadOptionMouseHook() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "MouseHook", (long)iVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionPageBtnDisp
//\bhFE`_CAÕy[W{^\IvVl̓Ǎ
//`    F  long loadOptionPageBtnDisp(
//              F  )
//^[l  FE`_CAÕy[W{^\IvVl
//O        FȂ
//쐬N  F2004/10/31
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int loadOptionPageBtnDisp( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "PBtnDisp", "1", cProfile );

	return( atoi(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionPageBtnDisp
//\bhFE`_CAÕy[W{^\IvVl̕ۑ
//`    F  void saveOptionPageBtnDisp(
//@@@@@@@F    [in]  long lVal F E`_CAÕy[W{^\IvVl
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2004/10/31
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionPageBtnDisp( int iVal )
{
	if ( iVal == loadOptionPageBtnDisp() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "PBtnDisp", (long)iVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionFirstPageDisp
//\bhF`[_CAȌy[W\IvVl̓Ǎ
//`    F  long loadOptionFirstPageDisp(
//              F  )
//^[l  F`[_CAȌy[W\IvVl
//O        FȂ
//쐬N  F2006/07/26
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int loadOptionFirstPageDisp( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "FirstPage", "0", cProfile );

	return( atoi(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionFirstPageDisp
//\bhF`[_CAȌy[W\IvVl̕ۑ
//`    F  void saveOptionPageBtnDisp(
//@@@@@@@F    [in]  long lVal F `[_CAȌy[W\IvVl
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2006/07/26
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionFirstPageDisp( int iVal )
{
	if ( iVal == loadOptionFirstPageDisp() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "FirstPage", (long)iVal );

	return;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FloadOptionSearchDisp
//\bhF_CAON\IvVl̓Ǎ
//`    F  long loadOptionSearchDisp(
//              F  )
//^[l  F_CAON\IvVl
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int loadOptionSearchDisp( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "SearchDisp", "0", cProfile );

	return( atoi(cProfile) );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FsaveOptionSearchDisp
//\bhF_CAON\IvVl̕ۑ
//`    F  void saveOptionSearchDisp(
//@@@@@@@F    [in]  long lVal F _CAON\IvVl
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC void saveOptionSearchDisp( int iVal )
{
	if ( iVal == loadOptionSearchDisp() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "SearchDisp", (long)iVal );

	return;
}

ExternC int dReplaceAmpasand( char* cDestStr, char* cSrcStr )
{
	char* pSearch1;
	char cTemp[SERVER_FNAME_MAX];
	int iPtr0;
	int iPtr1;

	//̃`FbN
	if ( cSrcStr == NULL ) {
		return(ERR_GENERAL);
	}
	else if ( cDestStr == NULL ) {
		return(ERR_GENERAL);
	}

	strcpy( cDestStr, "" );
	iPtr0 = 0;
	iPtr1 = 0;

	//擪p[^w
	for (;;) {
		pSearch1 = strchr( cSrcStr + iPtr0, '&' );
		if ( pSearch1 == NULL ) {
			//c蕶ׂăRs[
			strcat( cDestStr, cSrcStr + iPtr0 );
			//[v𔲂
			break;
		}
		else {
			iPtr1 = (int)(pSearch1 - cSrcStr);
			//擪̃p[^܂łRs[
			if ( iPtr1 - iPtr0 > 0 ) {
				memcpy( cTemp, cSrcStr + iPtr0, iPtr1 - iPtr0 );
				*(cTemp + iPtr1 - iPtr0) = '\0';
				strcat( cDestStr, cTemp );
			}
			strcat( cDestStr, "&&" );
			//|C^XV
			iPtr0 = iPtr1 + 1;
			//I[`FbN
			if ( *(cSrcStr + iPtr0) == '\0' ) {
				break;
			}
		}
	}

	return(NO_ERR);
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FGetSectionName
//\bhFZNV̎擾
//`    F  int GetSectionName(
//@@@@@@@F    [in]  int      iIndex          :  ZNVIndex
//@@@@@@@F    [out] CString* pCSectionName   :  {^ɑΉZNV
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
ExternC int GetSectionName( int iIndex, CString* pCSectionName )
{
	CString CButtonName;
	static char cIndex[36] = "123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ" ;

	TRY {
		if ( pCSectionName == NULL ) {
			return( -1 ) ;
		}

		if ( iIndex < 0 || iIndex >= EXEC_BUTTON_MAX ) {
			return( -1 ) ;
		}

		pCSectionName->Format( "%s%c", ICBTNSCTNAME, cIndex[iIndex] );

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int loadButtonOption( int iButtonIndex, int iSpinIndex, char* pcOption )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cTemp[EXEC_TEMP_MAX] ;
	CString csSpin;

	TRY {
		if ( pcOption == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		//t@C̎擾
		iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_OPTION, "", cTemp );
		CSectionName.ReleaseBuffer();

		strcpy( pcOption, cTemp );
		return( iRet );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int loadButtonIconFlag( int iButtonIndex, int iSpinIndex, char* pcIconFlag )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cTemp[EXEC_TEMP_MAX] ;
	CString csSpin;

	TRY {
		if ( pcIconFlag == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		//t@C̎擾
		iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONFLG, "0", cTemp );
		CSectionName.ReleaseBuffer();

		strcpy( pcIconFlag, cTemp );
		return( iRet );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int loadButtonIconName( int iButtonIndex, int iSpinIndex, char* pcIconName )
{
	int iRet = 0;
	CString CSectionName;
	char cTemp[EXEC_TEMP_MAX];
	CString csSpin;

	TRY {
		if ( pcIconName == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		//t@C̎擾
		iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONFILE, "", cTemp );
		CSectionName.ReleaseBuffer();

		strcpy( pcIconName, cTemp );
		return( iRet );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int loadButtonIconNum( int iButtonIndex, int iSpinIndex, char* pcIconNum )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cTemp[EXEC_TEMP_MAX] ;
	CString csSpin;

	TRY {
		if ( pcIconNum == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		//t@C̎擾
		iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONNUM, "0", cTemp );
		CSectionName.ReleaseBuffer();

		strcpy( pcIconNum, cTemp );
		return( iRet );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int loadButtonShowFlag( int iButtonIndex, int iSpinIndex, int* piIconShow )
{
	int iRet = 0;
	CString CSectionName;
	char cTemp[EXEC_TEMP_MAX];
	CString csSpin;

	TRY {
		if ( piIconShow == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 );
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		//t@C̎擾
		iRet = loadOptionCommon( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONSHOW, "0", cTemp );
		CSectionName.ReleaseBuffer();

		*piIconShow = atoi(cTemp);
		return( iRet );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int saveButtonOption( int iButtonIndex, int iSpinIndex, char* pcOption )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cIniFileName[512];
	CString csSpin;
	CString csTemp;

	TRY {
		if ( pcOption == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csTemp = pcOption;
		//IvV_uNH[e[VŊĂꍇ̏ 2008.07.14
		if ( csTemp.Left(1).CompareNoCase(_T("\"")) == 0 ) {
			csTemp = "\"" + csTemp;
		}
		if ( csTemp.Right(1).CompareNoCase(_T("\"")) == 0 ) {
			csTemp = csTemp + "\"";
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		//NIvV̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_OPTION, csTemp, cIniFileName );
		CSectionName.ReleaseBuffer();

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int saveButtonIconFlag( int iButtonIndex, int iSpinIndex, char* pcIconFlag )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cIniFileName[512];
	CString csSpin;

	TRY {
		if ( pcIconFlag == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		//ACRLtO̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONFLG, pcIconFlag, cIniFileName );
		CSectionName.ReleaseBuffer();

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int saveButtonIconName( int iButtonIndex, int iSpinIndex, char* pcIconName )
{
	int iRet = 0 ;
	CString CSectionName ;
	char cIniFileName[512];
	CString csSpin;

	TRY {
		if ( pcIconName == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		//ACRt@C̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONFILE, pcIconName, cIniFileName );
		CSectionName.ReleaseBuffer();

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int saveButtonIconNum( int iButtonIndex, int iSpinIndex, char* pcIconNum )
{
	int iRet = 0;
	CString CSectionName;
	char cIniFileName[512];
	CString csSpin;

	TRY {
		if ( pcIconNum == NULL ) {
			return( -1 );
		}

		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 ) ;
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		//ACRԍ̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONNUM, pcIconNum, cIniFileName );
		CSectionName.ReleaseBuffer();

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC int saveButtonShowFlag( int iButtonIndex, int iSpinIndex, int iIconShow )
{
	int iRet = 0;
	CString CSectionName;
	char cIniFileName[512];
	CString csSpin;
	CString csIconShow;

	TRY {
		if ( iButtonIndex < 0 || iButtonIndex >= EXEC_BUTTON_MAX ) {
			return( -1 );
		}

		if ( iSpinIndex > EXEC_PAGE_MAX ) {
			return( -1 );
		}

		//{^ɑΉZNV̎擾
		iRet = GetSectionName( iButtonIndex, &CSectionName );
		if ( iRet < 0 ) {
			return( -1 );
		}

		csSpin.Format( "%d", iSpinIndex );
		CSectionName += csSpin;

		getIniFileName( cIniFileName );

		csIconShow.Format( "%d", iIconShow );

		//\tO̕ۑ
		::WritePrivateProfileString( CSectionName.GetBuffer(CSectionName.GetLength()), EXEC_INI_ICONSHOW, csIconShow.GetBuffer(csIconShow.GetLength()), cIniFileName );
		CSectionName.ReleaseBuffer();
		csIconShow.ReleaseBuffer();

		return( 0 );
	}
	CATCH( CMemoryException, e ) {
		return( -1 );
	} END_CATCH
}

ExternC void saveOptionPageEditDlgX( long lVal )
{
	if ( lVal == loadOptionPageEditDlgX() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "PageEditDlgX", lVal );

	return;
}

ExternC void saveOptionPageEditDlgY( long lVal )
{
	if ( lVal == loadOptionPageEditDlgY() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "PageEditDlgY", lVal );

	return;
}

ExternC long loadOptionPageEditDlgX( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "PageEditDlgX", "400", cProfile );

	return( atol(cProfile) );
}

ExternC long loadOptionPageEditDlgY( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "PageEditDlgY", "50", cProfile );

	return( atol(cProfile) );
}

//Add v0.24
ExternC int _mbstat( char* pcFileName, struct _stat* pbuf )
{
	CString csFileName;
	CString csEXT;
	int iRet;

	csFileName = pcFileName;
	csEXT = "http:";
	if ( csEXT.Compare( csFileName.Left(5) ) == 0 ) {
		//URLȂ瑶݂̂ƂĈ
		return( 1 );
	}
	else {
		iRet = _stat(pcFileName, pbuf);
		if ( iRet != 0 ) {
			return( -1 );
		}
		else {
			return( 0 );
		}
	}
}
//Add v0.24

ExternC int loadOptionDisableHotKey( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "DisableHotKey", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionDisableHotKey( int iVal )
{
	if ( iVal == loadOptionDisableHotKey() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "DisableHotKey", (long)iVal );

	return;
}

ExternC int loadOptionEraseExecDlg( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "EraseExecDlg", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionEraseExecDlg( int iVal )
{
	if ( iVal == loadOptionEraseExecDlg() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "EraseExecDlg", (long)iVal );

	return;
}

ExternC int loadOptionHideExecDlg( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "HideExecDlg", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionHideExecDlg( int iVal )
{
	if ( iVal == loadOptionHideExecDlg() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "HideExecDlg", (long)iVal );

	return;
}

ExternC int loadOptionQuitExecDlg( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "QuitExecDlg", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionQuitExecDlg( int iVal )
{
	if ( iVal == loadOptionQuitExecDlg() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "QuitExecDlg", (long)iVal );

	return;
}

ExternC int loadOptionCommon( char* cSection, char* cKeyword, char* cDefault, char* cValue )
{
	char cIniFileName[512];
	long lProfileLen;

	//Iniݒ擾
	getIniFileName( cIniFileName );
	lProfileLen = ::GetPrivateProfileString( cSection, cKeyword, cDefault, cValue, 255, cIniFileName );
	if ( lProfileLen == 0 ) {
		strcpy( cValue, cDefault );
		return( -1 );
	}
	else {
		cValue[lProfileLen] = '\0';
		return( 0 );
	}

	return( 0 );
}

ExternC void saveOptionCommon( char* cKeyword, long lVal )
{
	char cIniFileName[512];
	CString csTemp;

	getIniFileName( cIniFileName );

	TRY {
		csTemp.Format( "%ld", lVal );
		::WritePrivateProfileString( "OPTION", cKeyword, csTemp, cIniFileName );
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH

	return;
}

ExternC long loadOptionHotKeyCode( void )
{
	char cProfile[256];
	CString csTemp;

	csTemp.Format( "%ld", VK_F12 );

	//Iniݒ擾
	loadOptionCommon( "OPTION", "HotKeyCode", csTemp.GetBuffer(csTemp.GetLength()), cProfile );
	csTemp.ReleaseBuffer();

	return( atol(cProfile) );
}

ExternC void saveOptionHotKeyCode( long lVal )
{
	if ( lVal == loadOptionHotKeyCode() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "HotKeyCode", lVal );

	return;
}

ExternC long loadOptionHotKeyCode2( void )
{
	char cProfile[256];
	CString csTemp;

	csTemp.Format( "%ld", VK_F11 );

	//Iniݒ擾
	loadOptionCommon( "OPTION", "HotKeyCode2", csTemp.GetBuffer(csTemp.GetLength()), cProfile );
	csTemp.ReleaseBuffer();

	return( atol(cProfile) );
}

ExternC void saveOptionHotKeyCode2( long lVal )
{
	if ( lVal == loadOptionHotKeyCode2() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "HotKeyCode2", lVal );

	return;
}

ExternC long loadOptionHotKeyMod( void )
{
	char cProfile[256];
	CString csTemp;

	csTemp.Format( "%ld", MOD_CONTROL | MOD_SHIFT );

	//Iniݒ擾
	loadOptionCommon( "OPTION", "HotKeyMod", csTemp.GetBuffer(csTemp.GetLength()), cProfile );
	csTemp.ReleaseBuffer();

	return( atol(cProfile) );
}

ExternC void saveOptionHotKeyMod( long lVal )
{
	if ( lVal == loadOptionHotKeyMod() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "HotKeyMod", lVal );

	return;
}

ExternC long loadOptionHotKeyMod2( void )
{
	char cProfile[256];
	CString csTemp;

	csTemp.Format( "%ld", MOD_CONTROL | MOD_SHIFT );

	//Iniݒ擾
	loadOptionCommon( "OPTION", "HotKeyMod2", csTemp.GetBuffer(csTemp.GetLength()), cProfile );
	csTemp.ReleaseBuffer();

	return( atol(cProfile) );
}

ExternC void saveOptionHotKeyMod2( long lVal )
{
	if ( lVal == loadOptionHotKeyMod2() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "HotKeyMod2", lVal );

	return;
}

ExternC long loadOptionMain_hWnd( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "hWnd", "0", cProfile );

	return( atol(cProfile) );
}

ExternC void saveOptionMain_hWnd( long lVal )
{
	if ( lVal == loadOptionMain_hWnd() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "hWnd", lVal );

	return;
}

ExternC int loadOptionMagnetExecDlg( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "MagnetExecDlg", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionMagnetExecDlg( int iVal )
{
	if ( iVal == loadOptionMagnetExecDlg() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "MagnetExecDlg", (long)iVal );

	return;
}

ExternC int loadOptionFullDrag( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "FullDrag", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionFullDrag( int iVal )
{
	if ( iVal == loadOptionFullDrag() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "FullDrag", (long)iVal );

	return;
}

ExternC int getDefaultIconIndex( char* pcFileName )
{
	CString csTemp;
	char cTemp[256];
	int iFindByte;
	unsigned long lType;
	DWORD dwSize;

	csTemp = pcFileName;

	iFindByte = csTemp.ReverseFind( '.' );
	if ( iFindByte >= 0 ) {
		csTemp = csTemp.Right( csTemp.GetLength() - iFindByte );
	}
	else {
		return 1;
	}

	HKEY hKey = NULL;

	//gqo^Ă邩ׂ
	if ( ::RegOpenKey( HKEY_CLASSES_ROOT, csTemp, &hKey ) != ERROR_SUCCESS ) {
		return 1;
	}
	else if ( hKey == NULL ) {
		return 1;
	}

	memset( cTemp, 0, sizeof(cTemp) );
	dwSize = 256;
	::RegQueryValueEx( hKey, NULL, NULL, &lType, (unsigned char*)cTemp, &dwSize );
	::RegCloseKey( hKey );
	hKey = NULL;

	if ( strlen(cTemp) != 0 ) {
		strcat( cTemp, "\\DefaultIcon\\" );
		//VF̓̒ACR𔲂
		if ( ::RegOpenKey( HKEY_CLASSES_ROOT, cTemp, &hKey ) != ERROR_SUCCESS ) {
			return 1;
		}
		else if ( hKey == NULL ) {
			return 1;
		}

		memset( cTemp, 0, sizeof(cTemp) );
		dwSize = 256;
		::RegQueryValueEx( hKey, NULL, NULL, &lType, (unsigned char*)cTemp, &dwSize );
		::RegCloseKey( hKey );
		hKey = NULL;

		if ( strlen(cTemp) == 0 ) {
			return 1;
		}

		csTemp = cTemp;

		iFindByte = csTemp.ReverseFind( ',' );
		if ( iFindByte > 0 ) {
			csTemp = csTemp.Right( csTemp.GetLength() - iFindByte - 1 );
		}
		else {
			return 1;
		}

		return atoi(csTemp);
	}
	else {
		return 1;
	}
}

ExternC int loadOptionMagnetSize( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "MagnetSize", "10", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionMagnetSize( int iVal )
{
	if ( iVal == loadOptionMagnetSize() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "MagnetSize", (long)iVal );

	return;
}

ExternC int loadOptionAutoHide( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "AutoHide", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionAutoHide( int iVal )
{
	if ( iVal == loadOptionAutoHide() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "AutoHide", (long)iVal );

	return;
}

ExternC int loadOptionDispTask( void )
{
	char cProfile[256];

	//Iniݒ擾
	loadOptionCommon( "OPTION", "DispTask", "0", cProfile );

	return( atoi(cProfile) );
}

ExternC void saveOptionDispTask( int iVal )
{
	if ( iVal == loadOptionDispTask() ) {
		//ݒlƓȂ炻̂܂܏I
		return;
	}

	saveOptionCommon( "DispTask", (long)iVal );

	return;
}

ExternC int jstrlen(char *lpszPtr)
{
	int count;
	BOOL bKanji = FALSE;

	count = 0;
	while ( *lpszPtr != '\0' ) {
		if ( bKanji == FALSE ) {
			if ( IsKanji_SJIS(*lpszPtr) ) {
				bKanji = TRUE;
			}
			else {
				bKanji = FALSE;
				count++;
			}
		}
		else {
			bKanji = FALSE;
			count++;
		}
		lpszPtr++;
	}
	return count;
}
