// PageEditDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Comfunc.h"
#include "mblaunch.h"
#include "PageDlg.h"
#include "PageEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// AvP[V`̃bZ[Wl
#define WMX_NOTIFYICON (WM_APP + 5)

/////////////////////////////////////////////////////////////////////////////
// CPageEditDlg _CAO


CPageEditDlg::CPageEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPageEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPageEditDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	int i;

	m_iPageCount = 0;
	m_iPageOldCount = 0;
	m_iPageOrgCount = 0;
	for ( i = 0; i < EXEC_PAGE_MAX; i++ ) {
		m_iPageIndex[i] = 0;
		m_pcsPageName[i] = NULL;
		m_lPageNoDisp[i] = 0;
	}

	Create( CPageEditDlg::IDD, pParent );
}


void CPageEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageEditDlg)
	DDX_Control(pDX, IDUP, m_BtnUp);
	DDX_Control(pDX, IDNEW, m_BtnNew);
	DDX_Control(pDX, IDEDIT, m_BtnEdit);
	DDX_Control(pDX, IDDOWN, m_BtnDown);
	DDX_Control(pDX, IDDEL, m_BtnDel);
	DDX_Control(pDX, IDC_PAGELIST, m_PageList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageEditDlg, CDialog)
	//{{AFX_MSG_MAP(CPageEditDlg)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDUP, OnUp)
	ON_BN_CLICKED(IDNEW, OnNew)
	ON_BN_CLICKED(IDDOWN, OnDown)
	ON_BN_CLICKED(IDDEL, OnDel)
	ON_BN_CLICKED(IDEDIT, OnEdit)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_PAGELIST, OnItemchangedPagelist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageEditDlg bZ[W nh

void CPageEditDlg::PostNcDestroy() 
{
//	CDialog::PostNcDestroy();
	delete this;
}

void CPageEditDlg::OnOK() 
{
	int iCount;
	int iTemp;
	int i;
	int j;
	char** ppcFileName = NULL;
	char** ppcTitle = NULL;
	char** ppcOption = NULL;
	int** ppiShowFlag = NULL;
	char** ppcIconFlag = NULL;
	char** ppcIconName = NULL;
	char** ppcIconNum = NULL;
	CString csTemp;

	//[v̌
	iCount = m_iPageCount;
	if ( iCount < m_iPageOldCount ) {
		iCount = m_iPageOldCount;
	}

	TRY {
		ppcFileName = new char*[iCount*EXEC_BUTTON_MAX];
		if ( ppcFileName == NULL ) {
			return;
		}
		ppcTitle = new char*[iCount*EXEC_BUTTON_MAX];
		if ( ppcTitle == NULL ) {
			return;
		}
		ppcOption = new char*[iCount*EXEC_BUTTON_MAX];
		if ( ppcOption == NULL ) {
			return;
		}
		ppiShowFlag = new int*[iCount*EXEC_BUTTON_MAX];
		if ( ppiShowFlag == NULL ) {
			return;
		}
		ppcIconFlag = new char*[iCount*EXEC_BUTTON_MAX];
		if ( ppcIconFlag == NULL ) {
			return;
		}
		ppcIconName = new char*[iCount*EXEC_BUTTON_MAX];
		if ( ppcIconName == NULL ) {
			return;
		}
		ppcIconNum = new char*[iCount*EXEC_BUTTON_MAX];
		if ( ppcIconNum == NULL ) {
			return;
		}
		for ( i = 0; i < iCount; i++ ) {
			for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
				ppcFileName[i*EXEC_BUTTON_MAX+j] = new char[FILELEN];
				ppcTitle[i*EXEC_BUTTON_MAX+j] = new char[FILELEN];
				ppcOption[i*EXEC_BUTTON_MAX+j] = new char[FILELEN];
				ppiShowFlag[i*EXEC_BUTTON_MAX+j] = new int[FILELEN];
				ppcIconFlag[i*EXEC_BUTTON_MAX+j] = new char[FILELEN];
				ppcIconName[i*EXEC_BUTTON_MAX+j] = new char[FILELEN];
				ppcIconNum[i*EXEC_BUTTON_MAX+j] = new char[FILELEN];
			}
		}

		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return;
		}

		//ύXÕf[^ǂݍ
//Update Start v0.32
//		iTemp = loadOptionAreaMax();
		iTemp = m_iPageOrgCount;
//Update End   v0.32
		for ( i = 0; i < iTemp; i++ ) {
			for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
				pApp->m_cIniInfo.loadButtonFileName( j, i, ppcFileName[i*EXEC_BUTTON_MAX+j] );
				pApp->m_cIniInfo.loadButtonTitle( j, i, ppcTitle[i*EXEC_BUTTON_MAX+j] );
				loadButtonOption( j, i, ppcOption[i*EXEC_BUTTON_MAX+j] );
				loadButtonShowFlag( j, i, ppiShowFlag[i*EXEC_BUTTON_MAX+j] );
				loadButtonIconFlag( j, i, ppcIconFlag[i*EXEC_BUTTON_MAX+j] );
				loadButtonIconName( j, i, ppcIconName[i*EXEC_BUTTON_MAX+j] );
				loadButtonIconNum( j, i, ppcIconNum[i*EXEC_BUTTON_MAX+j] );
			}
		}

		for ( i = 0; i < iCount; i++ ) {
			if ( i < m_iPageCount ) {
				if ( m_pcsPageName[i] != NULL ) {
					csTemp = *(m_pcsPageName[i]);
					pApp->m_cIniInfo.savePageName( i+1, csTemp.GetBuffer(csTemp.GetLength()+1) );
					csTemp.ReleaseBuffer();
				}
				pApp->m_cIniInfo.savePageNoDisp( i+1, m_lPageNoDisp[i] );
				if ( m_iPageIndex[i] < iTemp ) {
					if ( i != m_iPageIndex[i] ) {
						for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
							pApp->m_cIniInfo.saveButtonFileName( j, i, ppcFileName[m_iPageIndex[i]*EXEC_BUTTON_MAX+j] );
							pApp->m_cIniInfo.saveButtonTitle( j, i, ppcTitle[m_iPageIndex[i]*EXEC_BUTTON_MAX+j] );
							saveButtonOption( j, i, ppcOption[m_iPageIndex[i]*EXEC_BUTTON_MAX+j] );
							saveButtonShowFlag( j, i, *(ppiShowFlag[m_iPageIndex[i]*EXEC_BUTTON_MAX+j]) );
							saveButtonIconFlag( j, i, ppcIconFlag[m_iPageIndex[i]*EXEC_BUTTON_MAX+j] );
							saveButtonIconName( j, i, ppcIconName[m_iPageIndex[i]*EXEC_BUTTON_MAX+j] );
							saveButtonIconNum( j, i, ppcIconNum[m_iPageIndex[i]*EXEC_BUTTON_MAX+j] );
						}
					}
				}
				else {
					for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
						pApp->m_cIniInfo.saveButtonFileName( j, i, "" );
						pApp->m_cIniInfo.saveButtonTitle( j, i, "" );
						saveButtonOption( j, i, "" );
						saveButtonIconFlag( j, i, "" );
						saveButtonIconName( j, i, "" );
						saveButtonIconNum( j, i, "" );
					}
				}
			}
			else {
				pApp->m_cIniInfo.savePageName( i+1, "" );
				for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
					pApp->m_cIniInfo.saveButtonFileName( j, i, "" );
					pApp->m_cIniInfo.saveButtonTitle( j, i, "" );
					saveButtonOption( j, i, "" );
					saveButtonIconFlag( j, i, "" );
					saveButtonIconName( j, i, "" );
					saveButtonIconNum( j, i, "" );
				}
			}
		}

		pApp->m_cIniInfo.saveOptionAreaMax( m_iPageCount );

//Add Start v0.20
		if ( pApp->m_pccExecDlg != NULL ) {
			//ꎞIɃACRLbVOff
			int iVal = pApp->m_cIniInfo.loadOptionCacheIcon();
			pApp->m_cIniInfo.saveOptionCacheIcon( 0 );

			//E`_CAOUčĕ\
//			pApp->m_pccExecDlg->PostMessage( WM_SYSCOMMAND, SC_CLOSE, 0 );
			BOOL blDisp = pApp->m_pccExecDlg->m_blDisp;
			BOOL blHide = pApp->m_pccExecDlg->m_blHide;
			pApp->ExecClose();

			//ACRLbVɖ߂
			pApp->m_cIniInfo.saveOptionCacheIcon( iVal );

//			pApp->m_pccMainFrame->PostMessage( WMX_NOTIFYICON, 0, WM_LBUTTONDBLCLK );
			pApp->ExecDisp( blDisp, blHide );
		}
		else {
			CString FName;
			long i;

			char cFullName[EXECFILEMAX];
			char cPathName[EXECFILEMAX];

			::GetModuleFileName( NULL, cFullName, EXECFILEMAX-1 );
			splitPath( cPathName, cFullName );

			for ( i=0; i<EXEC_BUTTON_MAX; i++ ) {
				FName.Format( "%s\\mbcache%02ld.dat", cPathName, i );
				TRY
				{
					CFileStatus rStatus;
					if( CFile::GetStatus( FName, rStatus) == TRUE ) {
						CFile::Remove( FName );
					}
				}
				CATCH( CFileException, e )
				{
				}
				END_CATCH
			}
		}
//Add End   v0.20
//Add Start v0.29
		//j[LbVNA
		if ( pApp->m_pccMainFrame != NULL ) {
			pApp->m_pccMainFrame->DeleteMenuCache();
		}
//Add End   v0.29

//Add Start v1.01
		//NbvNA
		pApp->m_clipUse = 0;
//Add End   v1.01

		for ( i = 0; i < iCount; i++ ) {
			for ( j = 0; j < EXEC_BUTTON_MAX; j++ ) {
				delete ppcFileName[i*EXEC_BUTTON_MAX+j];
				delete ppcTitle[i*EXEC_BUTTON_MAX+j];
				delete ppcOption[i*EXEC_BUTTON_MAX+j];
				delete ppiShowFlag[i*EXEC_BUTTON_MAX+j];
				delete ppcIconFlag[i*EXEC_BUTTON_MAX+j];
				delete ppcIconName[i*EXEC_BUTTON_MAX+j];
				delete ppcIconNum[i*EXEC_BUTTON_MAX+j];
			}
		}

		if ( ppcFileName != NULL ) {
			delete ppcFileName;
			ppcFileName = NULL;
		}
		if ( ppcTitle != NULL ) {
			delete ppcTitle;
			ppcTitle = NULL;
		}
		if ( ppcOption != NULL ) {
			delete ppcOption;
			ppcOption = NULL;
		}
		if ( ppiShowFlag != NULL ) {
			delete ppiShowFlag;
			ppiShowFlag = NULL;
		}
		if ( ppcIconFlag != NULL ) {
			delete ppcIconFlag;
			ppcIconFlag = NULL;
		}
		if ( ppcIconName != NULL ) {
			delete ppcIconName;
			ppcIconName = NULL;
		}
		if ( ppcIconNum != NULL ) {
			delete ppcIconNum;
			ppcIconNum = NULL;
		}
	}
	CATCH( CMemoryException, e ) {
		return;
	} END_CATCH

//	CDialog::OnOK();
	DestroyWindow();
}

void CPageEditDlg::OnCancel() 
{
//	CDialog::OnCancel();
	DestroyWindow();
}

void CPageEditDlg::OnClose() 
{
//	CDialog::OnClose();
	DestroyWindow();
}

void CPageEditDlg::OnDestroy() 
{
	int i;

	m_PageList.DeleteAllItems();

	for ( i = 0; i < EXEC_PAGE_MAX; i++ ) {
		if ( m_pcsPageName[i] != NULL ) {
			delete m_pcsPageName[i];
			m_pcsPageName[i] = NULL;
		}
	}

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		RECT tagRect;
		GetWindowRect( &tagRect );
		saveOptionPageEditDlgX( tagRect.left );
		saveOptionPageEditDlgY( tagRect.top );
		pApp->m_pccPageEditDlg = NULL;
	}

	CDialog::OnDestroy();
}

BOOL CPageEditDlg::OnInitDialog() 
{
	LV_COLUMN listcol;
	LV_ITEM lvitem;
	char cTmp[256];
	CString csTemp;
	int i;

	CDialog::OnInitDialog();

	TRY {
		m_PageList.SetExtendedStyle(LVS_EX_FULLROWSELECT);

		// J}
		listcol.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;

		listcol.pszText = "߰ޔԍ";
		listcol.cx = 70;
		listcol.fmt = LVCFMT_CENTER;
		m_PageList.InsertColumn( 1, &listcol );

		listcol.pszText = "߰ޖ";
		listcol.cx = 120;
		listcol.fmt = LVCFMT_LEFT;
		m_PageList.InsertColumn( 2, &listcol );

		listcol.pszText = "ƭ\";
		listcol.cx = 70;
		listcol.fmt = LVCFMT_CENTER;
		m_PageList.InsertColumn( 3, &listcol );

		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return FALSE;
		}

		m_iPageCount = pApp->m_cIniInfo.loadOptionAreaMax();
		m_iPageOldCount = m_iPageCount;
		m_iPageOrgCount = m_iPageCount;
		for ( i = 0; i < m_iPageCount; i++ ) {
			pApp->m_cIniInfo.loadPageName( i+1, cTmp );

			m_iPageIndex[i] = i;
			m_lPageNoDisp[i] = pApp->m_cIniInfo.loadPageNoDisp( i+1 );
			m_pcsPageName[i] = new CString;
			if ( m_pcsPageName[i] != NULL ) {
				*(m_pcsPageName[i]) = cTmp;
			}
			else {
				return( FALSE );
			}

			// s̑}
			lvitem.mask = LVIF_TEXT;
			lvitem.iItem = i;
			lvitem.iSubItem = 0;
			lvitem.pszText = "";
			m_PageList.InsertItem( &lvitem );

			// f[^̐ݒ
			lvitem.iSubItem = 0;
			csTemp.Format( "%3d", i+1 );
			lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
			m_PageList.SetItem( &lvitem );
			csTemp.ReleaseBuffer( -1 );

			lvitem.iSubItem = 1;
			csTemp = cTmp;
			lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
			m_PageList.SetItem( &lvitem );
			csTemp.ReleaseBuffer( -1 );

			lvitem.iSubItem = 2;
			if ( m_lPageNoDisp[i] == 0 ) {
				lvitem.pszText = "";
			}
			else {
				lvitem.pszText = "|";
			}
			m_PageList.SetItem( &lvitem );
		}

		if ( m_iPageCount != 0 ) {
			m_PageList.SetItemState( 0, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
		}

	}
	CATCH( CFileException, e ) {
		return( TRUE );
	}
	CATCH( CMemoryException, e ) {
		return( TRUE );
	} END_CATCH

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageEditDlg::OnUp() 
{
	int iPageNo;
	int iPageNo2;
	POSITION pos;
	int i;
	LV_ITEM lvitem;
	CString csTemp;
	CString* pcsWork;
	long lWork;

	pos = m_PageList.GetFirstSelectedItemPosition();
	if ( pos == NULL ) {
		return;
	}
	iPageNo  = (int)pos-1;
	iPageNo2 = (int)pos-2;

	pcsWork = m_pcsPageName[iPageNo2];
	m_pcsPageName[iPageNo2] = m_pcsPageName[iPageNo];
	m_pcsPageName[iPageNo] = pcsWork;

	lWork = m_lPageNoDisp[iPageNo2];
	m_lPageNoDisp[iPageNo2] = m_lPageNoDisp[iPageNo];
	m_lPageNoDisp[iPageNo] = lWork;

	i = m_iPageIndex[iPageNo2];
	m_iPageIndex[iPageNo2] = m_iPageIndex[iPageNo];
	m_iPageIndex[iPageNo] = i;

	//Xg̍XV
	lvitem.mask = LVIF_TEXT;
	lvitem.iItem = (int)pos-2;
	lvitem.iSubItem = 0;
	csTemp.Format( "%3d", (int)pos-2+1 );
	lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
	m_PageList.SetItem( &lvitem );
	csTemp.ReleaseBuffer( -1 );

	lvitem.iSubItem = 1;
	if ( m_pcsPageName[iPageNo-1] != NULL ) {
		csTemp = *(m_pcsPageName[iPageNo-1]);
		lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
		csTemp.ReleaseBuffer( -1 );
	}
	else {
		lvitem.pszText = "";
	}
	m_PageList.SetItem( &lvitem );

	lvitem.iSubItem = 2;
	if ( m_lPageNoDisp[iPageNo-1] == 0 ) {
		lvitem.pszText = "";
	}
	else {
		lvitem.pszText = "|";
	}
	m_PageList.SetItem( &lvitem );

	lvitem.mask = LVIF_TEXT;
	lvitem.iItem = (int)pos-1;
	lvitem.iSubItem = 0;
	csTemp.Format( "%3d", (int)pos-1+1 );
	lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
	m_PageList.SetItem( &lvitem );
	csTemp.ReleaseBuffer( -1 );

	lvitem.iSubItem = 1;
	if ( m_pcsPageName[iPageNo-1] != NULL ) {
		csTemp = *(m_pcsPageName[iPageNo]);
		lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
		csTemp.ReleaseBuffer( -1 );
	}
	else {
		lvitem.pszText = "";
	}
	m_PageList.SetItem( &lvitem );

	lvitem.iSubItem = 2;
	if ( m_lPageNoDisp[iPageNo] == 0 ) {
		lvitem.pszText = "";
	}
	else {
		lvitem.pszText = "|";
	}
	m_PageList.SetItem( &lvitem );

	m_PageList.SetItemState( (int)pos-2, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
	m_PageList.EnsureVisible( (int)pos-2, FALSE );

	return;
}

void CPageEditDlg::OnNew() 
{
	CPageDlg cPageDlg;
	LV_ITEM lvitem;
	CString csTemp;

	cPageDlg.m_iPageNo = m_iPageCount+1;
//Update Start v0.32
//	cPageDlg.m_csPageName = "";
	cPageDlg.m_csPageName.Format( "߰%3d", m_iPageCount+1 );
//Update End   v0.32
	cPageDlg.m_lPageNoDisp = 0;
	if ( cPageDlg.DoModal() == IDOK ) {
		m_lPageNoDisp[m_iPageCount] = cPageDlg.m_lPageNoDisp;
		m_pcsPageName[m_iPageCount] = new CString;
		if ( m_pcsPageName[m_iPageCount] != NULL ) {
			*(m_pcsPageName[m_iPageCount]) = cPageDlg.m_csPageName;
		}
		else {
			return;
		}
		m_iPageIndex[m_iPageCount] = m_iPageOldCount;
		m_iPageOldCount++;

		// s̑}
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = m_iPageCount;
		lvitem.iSubItem = 0;
		lvitem.pszText = "";
		m_PageList.InsertItem( &lvitem );

		// f[^̐ݒ
		lvitem.iSubItem = 0;
		csTemp.Format( "%3d", m_iPageCount+1 );
		lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
		m_PageList.SetItem( &lvitem );
		csTemp.ReleaseBuffer( -1 );

		lvitem.iSubItem = 1;
		csTemp = cPageDlg.m_csPageName;
		lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
		m_PageList.SetItem( &lvitem );
		csTemp.ReleaseBuffer( -1 );

		lvitem.iSubItem = 2;
		if ( cPageDlg.m_lPageNoDisp == 0 ) {
			lvitem.pszText = "";
		}
		else {
			lvitem.pszText = "|";
		}
		m_PageList.SetItem( &lvitem );

		m_PageList.SetItemState( m_iPageCount, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
		m_PageList.EnsureVisible( m_iPageCount, FALSE );

		m_iPageCount++;

//Add Start v0.50
		if ( m_iPageCount <= 1 ) {
			m_BtnDel.EnableWindow( FALSE );
		}
		else {
			m_BtnDel.EnableWindow( TRUE );
		}
//Add End   v0.50
	}
}

void CPageEditDlg::OnDown() 
{
	int iPageNo;
	int iPageNo2;
	POSITION pos;
	int i;
	LV_ITEM lvitem;
	CString csTemp;
	CString* pcsWork;
	long lWork;

	pos = m_PageList.GetFirstSelectedItemPosition();
	if ( pos == NULL ) {
		return;
	}
	iPageNo  = (int)pos-1;
	iPageNo2 = (int)pos;

	pcsWork = m_pcsPageName[iPageNo2];
	m_pcsPageName[iPageNo2] = m_pcsPageName[iPageNo];
	m_pcsPageName[iPageNo] = pcsWork;

	lWork = m_lPageNoDisp[iPageNo2];
	m_lPageNoDisp[iPageNo2] = m_lPageNoDisp[iPageNo];
	m_lPageNoDisp[iPageNo] = lWork;

	i = m_iPageIndex[iPageNo2];
	m_iPageIndex[iPageNo2] = m_iPageIndex[iPageNo];
	m_iPageIndex[iPageNo] = i;

	//Xg̍XV
	lvitem.mask = LVIF_TEXT;
	lvitem.iItem = (int)pos;
	lvitem.iSubItem = 0;
	csTemp.Format( "%3d", (int)pos+1 );
	lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
	m_PageList.SetItem( &lvitem );
	csTemp.ReleaseBuffer( -1 );

	lvitem.iSubItem = 1;
	csTemp = *(m_pcsPageName[iPageNo+1]);
	lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
	m_PageList.SetItem( &lvitem );
	csTemp.ReleaseBuffer( -1 );

	lvitem.iSubItem = 2;
	if ( m_lPageNoDisp[iPageNo+1] == 0 ) {
		lvitem.pszText = "";
	}
	else {
		lvitem.pszText = "|";
	}
	m_PageList.SetItem( &lvitem );

	lvitem.mask = LVIF_TEXT;
	lvitem.iItem = (int)pos-1;
	lvitem.iSubItem = 0;
	csTemp.Format( "%3d", (int)pos-1+1 );
	lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
	m_PageList.SetItem( &lvitem );
	csTemp.ReleaseBuffer( -1 );

	lvitem.iSubItem = 1;
	csTemp = *(m_pcsPageName[iPageNo]);
	lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
	m_PageList.SetItem( &lvitem );
	csTemp.ReleaseBuffer( -1 );

	lvitem.iSubItem = 2;
	if ( m_lPageNoDisp[iPageNo] == 0 ) {
		lvitem.pszText = "";
	}
	else {
		lvitem.pszText = "|";
	}
	m_PageList.SetItem( &lvitem );

	m_PageList.SetItemState( (int)pos, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
	m_PageList.EnsureVisible( (int)pos, FALSE );

	return;
}

void CPageEditDlg::OnDel() 
{
	int iPageNo;
	POSITION pos;
	int i;
	LV_ITEM lvitem;
	CString csTemp;
	int iPos;

	pos = m_PageList.GetFirstSelectedItemPosition();
	if ( pos == NULL ) {
		return;
	}
	iPageNo = m_iPageIndex[(int)pos-1];

	if ( m_pcsPageName[(int)pos-1] != NULL ) {
		delete m_pcsPageName[(int)pos-1];
		m_pcsPageName[(int)pos-1] = NULL;
	}

	m_iPageCount--;

//	for ( i = iPageNo; i < m_iPageCount; i++ ) {
//		m_iPageIndex[i] = m_iPageIndex[i+1];
//		m_pcsPageName[i] = m_pcsPageName[i+1];
//		m_lPageNoDisp[i] = m_lPageNoDisp[i+1];
//	}
//	m_pcsPageName[m_iPageCount] = NULL;
	for ( i = (int)pos-1; i < EXEC_PAGE_MAX-1; i++ ) {
		m_iPageIndex[i] = m_iPageIndex[i+1];
		m_pcsPageName[i] = m_pcsPageName[i+1];
		m_lPageNoDisp[i] = m_lPageNoDisp[i+1];
	}
	m_pcsPageName[EXEC_PAGE_MAX-1] = NULL;

	m_PageList.DeleteItem( (int)pos-1 );

	for ( i = (int)pos-1; i < m_iPageCount; i++ ) {
		//Xg̍XV
		lvitem.mask = LVIF_TEXT;
		lvitem.iItem = i;
		lvitem.iSubItem = 0;
		csTemp.Format( "%3d", i+1 );
		lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
		m_PageList.SetItem( &lvitem );
		csTemp.ReleaseBuffer( -1 );
	}

	if ( (int)pos-1 < m_iPageCount ) {
		iPos = (int)pos-1;
	}
	else {
		iPos = (int)pos-2;
	}
	m_PageList.SetItemState( iPos, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
	m_PageList.EnsureVisible( iPos, FALSE );

	return;
}

void CPageEditDlg::OnEdit() 
{
	CPageDlg cPageDlg;
	int iPageNo;
	POSITION pos;
	LV_ITEM lvitem;
	CString csTemp;

	pos = m_PageList.GetFirstSelectedItemPosition();
	if ( pos == NULL ) {
		return;
	}
	iPageNo = (int)pos-1;

	cPageDlg.m_iPageNo = iPageNo+1;
	cPageDlg.m_lPageNoDisp = m_lPageNoDisp[iPageNo];
	if ( m_pcsPageName[iPageNo] != NULL ) {
		cPageDlg.m_csPageName = *(m_pcsPageName[iPageNo]);
	}
	else {
		return;
	}
	if ( cPageDlg.DoModal() == IDOK ) {
		if ( m_pcsPageName[iPageNo] != NULL ) {
			m_lPageNoDisp[iPageNo] = cPageDlg.m_lPageNoDisp;
			*(m_pcsPageName[iPageNo]) = cPageDlg.m_csPageName;
			//Xg̍XV
			lvitem.mask = LVIF_TEXT;
			lvitem.iItem = iPageNo;

			lvitem.iSubItem = 1;
			csTemp = cPageDlg.m_csPageName;
			lvitem.pszText = csTemp.GetBuffer( csTemp.GetLength() + 1 );
			m_PageList.SetItem( &lvitem );
			csTemp.ReleaseBuffer( -1 );

			lvitem.iSubItem = 2;
			if ( cPageDlg.m_lPageNoDisp == 0 ) {
				lvitem.pszText = "";
			}
			else {
				lvitem.pszText = "|";
			}
			m_PageList.SetItem( &lvitem );
		}
		else {
			return;
		}
	}
}

void CPageEditDlg::OnItemchangedPagelist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;
	int iPageNo;
	long lPageMax;
	POSITION pos;

	pos = m_PageList.GetFirstSelectedItemPosition();
	if ( pos == NULL ) {
		m_BtnUp.EnableWindow( FALSE );
		m_BtnDown.EnableWindow( FALSE );
		m_BtnEdit.EnableWindow( FALSE );
		m_BtnDel.EnableWindow( FALSE );
	}
	else {
		iPageNo = (int)pos - 1;
		if ( iPageNo > 0 ) {
			m_BtnUp.EnableWindow( TRUE );
		}
		else {
			m_BtnUp.EnableWindow( FALSE );
		}
		lPageMax = m_iPageCount;
		if ( iPageNo < lPageMax-1 ) {
			m_BtnDown.EnableWindow( TRUE );
		}
		else {
			m_BtnDown.EnableWindow( FALSE );
		}
		m_BtnEdit.EnableWindow( TRUE );
//Add Start v0.50
		if ( lPageMax <= 1 ) {
			m_BtnDel.EnableWindow( FALSE );
		}
		else {
			m_BtnDel.EnableWindow( TRUE );
		}
//Add End   v0.50
	}

	return;
}
