// SearchDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Comfunc.h"
#include "mblaunch.h"
#include "SearchDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SearchDlg _CAO


SearchDlg::SearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(SearchDlg)
	//}}AFX_DATA_INIT

	m_iHideSize = 0;
	m_iMagnet = 0;
	m_blHide = FALSE;

	Create( SearchDlg::IDD, pParent );
}


//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FSearchDlg::PostNcDestroy
//\bhFEBhEfXgC̃Cxgnh
//`    F  void SearchDlg::PostNcDestroy(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void SearchDlg::PostNcDestroy() 
{
//	CDialog::PostNcDestroy();
	delete this;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FSearchDlg::OnClose
//\bhF_CAON[ỸCxgnh
//`    F  void SearchDlg::OnClose(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void SearchDlg::OnClose() 
{
//	CDialog::OnClose();
	DestroyWindow();
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FSearchDlg::OnDestroy
//\bhFfXgC̃Cxgnh
//`    F  void SearchDlg::OnDestroy(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void SearchDlg::OnDestroy() 
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		RECT tagRect;
		GetWindowRect( &tagRect );
		saveOptionSearchDlgX( tagRect.left );
		saveOptionSearchDlgY( tagRect.top );
		pApp->m_pccSearchDlg = NULL;
	}

	CDialog::OnDestroy();
}

void SearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SearchDlg)
	DDX_Control(pDX, IDC_RUNICON, m_RunIcon);
	DDX_Control(pDX, IDC_EDIT1, m_SearchStr);
	DDX_Control(pDX, ID_SEARCH, m_SearchBtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(SearchDlg, CDialog)
	//{{AFX_MSG_MAP(SearchDlg)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(ID_SEARCH, OnSearch)
	ON_WM_NCLBUTTONDBLCLK()
	ON_CBN_EDITCHANGE(IDC_EDIT1, OnEditchangeEdit1)
	ON_CBN_SELCHANGE(IDC_EDIT1, OnSelchangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SearchDlg bZ[W nh

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FSearchDlg::OnInitDialog
//\bhF_CAÕCxgnh
//`    F  BOOL SearchDlg::OnInitDialog(
//              F  )
//^[l  FTRUE, sFALSE
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
BOOL SearchDlg::OnInitDialog() 
{
	CString csTemp;
	int i;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return FALSE;
	}

	CDialog::OnInitDialog();

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if ( pSysMenu != NULL ) {
		pSysMenu->AppendMenu( MF_SEPARATOR );

		pSysMenu->AppendMenu( MF_STRING, IDM_DLGHIDE, "ʂB" );
	}

	m_befLen = 0;
	m_befLen2 = 0;
	m_Mode = 0;

	for ( i = 0; i < _LIST_MAX; i++ ) {
		m_iListPage[i]   = -1;
		m_iListButton[i] = -1;
	}

	m_hRunIcon = NULL;
	m_RunIcon.SetIcon( m_hRunIcon );

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FSearchDlg::OnCancel
//\bhFLZ̃Cxgnh
//`    F  void SearchDlg::OnCancel(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2002/09/24
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void SearchDlg::OnCancel() 
{
	DestroyWindow();
}

void SearchDlg::OnSearch() 
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	if ( m_Mode == 0 ) {

		CMenu cMenu;
		BOOL bRet = 0;
		CMenu* pPopup;

		//|bvAbvj[̓ǂݍ
		bRet = cMenu.LoadMenu( IDR_POPUPMENU ) ;
		if ( bRet == 0 ) {
			//j[ǂݍݎs
			return ;
		}

		//|bvAbvj[̎擾
		pPopup = cMenu.GetSubMenu( 2 ) ;
		if ( pPopup == NULL ) {
			//|bvAbv j[擾s
			return ;
		}

		RECT tagRect;
		m_SearchBtn.GetWindowRect( &tagRect );
		pPopup->TrackPopupMenu( TPM_LEFTALIGN | TPM_LEFTBUTTON, tagRect.left, tagRect.top, this );
	}
	else {
		UINT wParam;
		wParam = m_iPage * EXEC_BUTTON_MAX + m_iButton;
		pApp->m_pccMainFrame->OnCommand2( (UINT)wParam );
	}

	return;
}

void SearchDlg::OnNcLButtonDblClk(UINT nHitTest, CPoint point) 
{
	BOOL blDisp;

	if ( m_blHide == FALSE ) {
		blDisp = FALSE;
	}
	else {
		blDisp = TRUE;
	}

	ChangeDialogStyle( blDisp );

	CDialog::OnNcLButtonDblClk(nHitTest, point);
}

void SearchDlg::ChangeDialogStyle( BOOL blDisp )
{
	CRect ccRect;
	CRect ccRectClient;

	if ( blDisp == TRUE ) {
		if ( m_blHide == FALSE ) {
			return;
		}

		//_CAOTCY̕ύX
		GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		if ( IsMagnetUnderTask( ccRect ) == TRUE ) {
			if ( m_iHideSize != 0 ) {
				ccRect.top -= m_iHideSize;
			}
			else {
				ccRect.top -= 75;
			}
		}
		else {
			if ( m_iHideSize != 0 ) {
				ccRect.bottom += m_iHideSize;
			}
			else {
				ccRect.bottom += 75;
			}
		}
		MoveWindow( &ccRect, TRUE );

		CMenu* pSysMenu = GetSystemMenu( FALSE );
		if ( pSysMenu != NULL ) {
			pSysMenu->ModifyMenu( IDM_DLGHIDE, MF_BYCOMMAND | MF_STRING, IDM_DLGHIDE, "ʂB" );
		}

		m_blHide = FALSE;
	}
	else {
		if ( m_blHide == TRUE ) {
			return;
		}

		//_CAOTCY̕ύX
		GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		GetClientRect( &ccRectClient );
		ccRectClient.NormalizeRect();
		if ( IsMagnetUnderTask( ccRect ) == TRUE ) {
			ccRect.top += ccRectClient.bottom - ccRectClient.top + 1;
		}
		else {
			ccRect.bottom -= ccRectClient.bottom - ccRectClient.top + 1;
		}
		m_iHideSize = ccRectClient.bottom - ccRectClient.top + 1;
		MoveWindow( &ccRect, TRUE );

		CMenu* pSysMenu = GetSystemMenu( FALSE );
		if ( pSysMenu != NULL ) {
			pSysMenu->ModifyMenu( IDM_DLGHIDE, MF_BYCOMMAND | MF_STRING, IDM_DLGHIDE, "ʂ\" );
		}

		m_blHide = TRUE;
	}

	return;
}

BOOL SearchDlg::IsMagnetUnderTask( CRect& ccRect )
{
	if ( m_iMagnet != 0 ) {
		const char *pszTaskBar="Shell_TrayWnd";
		HWND hWnd = ::FindWindow( pszTaskBar, NULL );
		if ( hWnd != NULL ) {
			RECT RectTask;
			::GetWindowRect( hWnd, &RectTask );
			//ɂ^XNo[ɂĂ鎞
			if ( labs(RectTask.top - ccRect.bottom) == 0 ) {
				return TRUE;
			}
			else {
				return FALSE;
			}
		}
		else {
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
}

void SearchDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	if ((nID & 0xFFF0) == IDM_DLGHIDE ) {
		BOOL blDisp;

		if ( m_blHide == FALSE ) {
			blDisp = FALSE;
		}
		else {
			blDisp = TRUE;
		}

		ChangeDialogStyle( blDisp );
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

void SearchDlg::OnEditchangeEdit1() 
{
	int iPageCount;
	int i;
	int j;
	int iLen;
	int iLenZ;
	char* pcTitle = NULL;
	char* pcTemp = NULL;
	char* pcTemp2 = NULL;
	CString csTemp;
	int absmatchFlg = 0;
	int endFlg = 0;
	int iListCount;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	if ( m_hRunIcon != NULL ) {
		::DestroyIcon( m_hRunIcon );
		m_hRunIcon = NULL;
	}

	if ( pApp->m_cIniInfo.loadOptionSearchRun() == 0 ) {
		m_Mode = 0;
		m_befLen = 0;
		m_befLen2 = 0;
		m_SearchBtn.SetWindowText( "" );

		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}

	m_SearchStr.GetWindowText(csTemp);
	iLen = csTemp.GetLength();
	iLenZ = jstrlen(csTemp.GetBuffer(csTemp.GetLength()));
	csTemp.ReleaseBuffer();

	if ( iLenZ == 0 || (m_Mode == 1 && iLenZ == m_befLen - m_befLen2) ) {
		m_Mode = 0;
		m_befLen = iLenZ;
		m_befLen2 = 0;

		if ( m_Mode == 1 ) {
			m_SearchBtn.SetWindowText( "s" );
		}
		else {
			m_SearchBtn.SetWindowText( "" );
		}

		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}
	else if ( m_Mode == 0 && iLenZ == m_befLen - 1 ) {
		absmatchFlg = 1;
	}

	m_Mode = 0;

	pcTitle = new char[FILELEN];
	if ( pcTitle == NULL ) {
		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}
	pcTemp = new char[FILELEN];
	if ( pcTemp == NULL ) {
		if ( pcTitle != NULL ) {
			delete pcTitle;
			pcTitle = NULL;
		}
		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}
	pcTemp2 = new char[FILELEN];
	if ( pcTemp2 == NULL ) {
		if ( pcTitle != NULL ) {
			delete pcTitle;
			pcTitle = NULL;
		}
		if ( pcTemp != NULL ) {
			delete pcTemp;
			pcTemp = NULL;
		}
		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}

	j = m_SearchStr.GetCount();
	for ( i = j-1; i >= 0; i-- ) {
		m_SearchStr.DeleteString( i );
	}
	iListCount = 0;

	endFlg = 0;
	iPageCount = pApp->m_cIniInfo.loadOptionAreaMax();
	for ( i = 0; i < iPageCount; i++ ) {
		if ( endFlg == 2 ) {
			break;
		}
		for ( j = 0; j < pApp->m_cIniInfo.loadOptionButtonCount(); j++ ) {
			pApp->m_cIniInfo.loadButtonTitle( j, i, pcTitle );
			if ( pcTitle[0] != '\0' ) {
				strncpy( pcTemp, pcTitle, iLen );
				pcTemp[iLen] = '\0';
				if ( csTemp.CompareNoCase(pcTemp) == 0 ) {
					if ( csTemp.CompareNoCase(pcTitle) != 0 ) {
						if ( absmatchFlg != 1 ) {
							if ( endFlg == 0 ) {
								m_SearchStr.AddString( pcTitle );
								m_iListPage[iListCount]   = i;
								m_iListButton[iListCount] = j;
								iListCount++;
								m_SearchStr.SetWindowText( pcTitle );
								m_SearchStr.SetEditSel( iLenZ, jstrlen(pcTitle) );
								m_befLen2 = jstrlen(pcTitle) - iLenZ;
								iLenZ = jstrlen(pcTitle);
								m_Mode = 1;
								m_iPage = i;
								m_iButton = j;

								SetRunIcon();

								endFlg = 1;

							}
							else {
								m_SearchStr.AddString( pcTitle );
								m_iListPage[iListCount]   = i;
								m_iListButton[iListCount] = j;
								iListCount++;
							}
							if ( iListCount >= _LIST_MAX ) {
								endFlg = 2;
								break;
							}
						}
					}
					else {
						if ( endFlg == 0 ) {
							m_Mode = 1;
							m_iPage = i;
							m_iButton = j;

							SetRunIcon();

							endFlg = 1;
							m_SearchStr.AddString( pcTitle );
							m_iListPage[iListCount]   = i;
							m_iListButton[iListCount] = j;

							iListCount++;
						}
						else {
							m_SearchStr.AddString( pcTitle );
							m_iListPage[iListCount]   = i;
							m_iListButton[iListCount] = j;
							iListCount++;
						}
						if ( iListCount >= _LIST_MAX ) {
							endFlg = 2;
							break;
						}
					}
				}
			}
		}
	}

	m_befLen = iLenZ;

	if ( pcTemp2 != NULL ) {
		delete pcTemp2;
		pcTemp2 = NULL;
	}
	if ( pcTemp != NULL ) {
		delete pcTemp;
		pcTemp = NULL;
	}
	if ( pcTitle != NULL ) {
		delete pcTitle;
		pcTitle = NULL;
	}

	if ( m_Mode == 1 ) {
		m_SearchBtn.SetWindowText( "s" );
	}
	else {
		m_SearchBtn.SetWindowText( "" );
	}

	m_RunIcon.SetIcon( m_hRunIcon );
	return;
}

void SearchDlg::OnSelchangeEdit1() 
{
	int index;
	CString csTemp;
	char* pcTemp2 = NULL;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	pcTemp2 = new char[FILELEN];
	if ( pcTemp2 == NULL ) {
		return;
	}

	if ( m_hRunIcon != NULL ) {
		::DestroyIcon( m_hRunIcon );
		m_hRunIcon = NULL;
	}

	if ( m_Mode == 1 ) {
		index = m_SearchStr.GetCurSel();
		if ( index != CB_ERR ) {
//			WPARAM wParam;
//			LPARAM lParam;
//			wParam = m_iListPage[index] * EXEC_BUTTON_MAX + m_iListButton[index];
//			lParam = 0;
//			pApp->m_pccMainFrame->OnCommand( wParam, lParam );

			m_iPage = m_iListPage[index];
			m_iButton = m_iListButton[index];

			SetRunIcon();

			m_SearchStr.GetLBText( index, csTemp );
			m_befLen = jstrlen(csTemp.GetBuffer(csTemp.GetLength()));
			csTemp.ReleaseBuffer();
			m_befLen2 = 0;
		}
	}

	m_RunIcon.SetIcon( m_hRunIcon );
	return;
}

BOOL SearchDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	TRY {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return FALSE;
		}

		if ( HIWORD(wParam) == 0 ) {
			if ( LOWORD(wParam) == ID_SRHGOOGLE ) {
				CString csStr;
				CString csTemp;

				csStr = SEARCH_PARA01;

				if ( pApp->m_cIniInfo.loadOptionSearchMode() != 0 ) {
					csStr += SEARCH_PARA02;
				}

				csStr += SEARCH_PARA03;

				m_SearchStr.GetWindowText(csTemp);
				csStr += csTemp;

				ExecStart( csStr.GetBuffer(csStr.GetLength()), NULL, 0 );
				csStr.ReleaseBuffer();
			}
			else if ( LOWORD(wParam) == ID_SRHAMAZON ) {
				CString csStr;
				CString csTemp;

				csStr = SEARCH_PARA04;

				m_SearchStr.GetWindowText(csTemp);
				csStr += csTemp;

				ExecStart( csStr.GetBuffer(csStr.GetLength()), NULL, 0 );
				csStr.ReleaseBuffer();
			}
			else {
				return CDialog::OnCommand(wParam, lParam);
			}
			return FALSE;
		}
		else {
			return CDialog::OnCommand(wParam, lParam);
		}
	}
	CATCH( CMemoryException, e ) {
		return FALSE;
	} END_CATCH
}

void SearchDlg::SetRunIcon( void )
{
	struct _stat buf;			//t@C݃`FbNp
	char* pcTemp   = NULL;
	char* pcTemp2 = NULL;
	char* pcTemp3 = NULL;
	int iNum;
	int iRet;

	if ( m_hRunIcon != NULL ) {
		::DestroyIcon( m_hRunIcon );
		m_hRunIcon = NULL;
	}

	pcTemp = new char[FILELEN];
	if ( pcTemp == NULL ) {
		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}
	pcTemp2 = new char[FILELEN];
	if ( pcTemp2 == NULL ) {
		if ( pcTemp != NULL ) {
			delete pcTemp;
			pcTemp = NULL;
		}
		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}
	pcTemp3 = new char[FILELEN];
	if ( pcTemp3 == NULL ) {
		if ( pcTemp2 != NULL ) {
			delete pcTemp2;
			pcTemp2 = NULL;
		}
		if ( pcTemp != NULL ) {
			delete pcTemp;
			pcTemp = NULL;
		}
		m_RunIcon.SetIcon( m_hRunIcon );
		return;
	}

	loadButtonIconName( m_iButton, m_iPage, pcTemp2 );
	if ( loadButtonIconNum(m_iButton, m_iPage, pcTemp3) < 0 ) {
		iNum = 0;
	}
	else {
		iNum = atoi( pcTemp3 );
	}

	//ϐ̒u
	dReplaceEnvParam( pcTemp, pcTemp2 );

	if ( strlen( pcTemp ) != 0 ) {
		//t@C̑݃`FbN
		iRet = _mbstat( pcTemp, &buf );
		if ( iRet == 0 ) {
			::ExtractIconEx( pcTemp, iNum, NULL, &m_hRunIcon, 1 );
			if ( m_hRunIcon == NULL ) {
				//ftHg̃AvP[VACR̎擾
				int cx = GetSystemMetrics(SM_CXSMICON);  // X[ACR̕
				int cy = GetSystemMetrics(SM_CYSMICON);  // X[ACR̍
				m_hRunIcon = (HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_DEFICON), IMAGE_ICON, cx, cy, LR_DEFAULTCOLOR);
			}
		}
		else if ( iRet == 1 ) {
			//ftHg̃AvP[VACR̎擾
			int cx = GetSystemMetrics(SM_CXSMICON);  // X[ACR̕
			int cy = GetSystemMetrics(SM_CYSMICON);  // X[ACR̍
			m_hRunIcon = (HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_WEBICON), IMAGE_ICON, cx, cy, LR_DEFAULTCOLOR);
		}
		else {
			//ACR̃NA
			m_hRunIcon = NULL;
		}
	}
	else {
		//ACR̃NA
		m_hRunIcon = NULL;
	}

	if ( pcTemp3 != NULL ) {
		delete pcTemp3;
		pcTemp3 = NULL;
	}
	if ( pcTemp2 != NULL ) {
		delete pcTemp2;
		pcTemp2 = NULL;
	}
	if ( pcTemp != NULL ) {
		delete pcTemp;
		pcTemp = NULL;
	}

	return;
}
