//%SF_HEAD_BGN
//==============================================================================
//\[X́FCExecDlg
//\[XFE`_CAONX
//쐬NF2000/11/29
//쐬Җ  FMacBS
//l      F
//==============================================================================
//%SF_HEAD_END

#include "stdafx.h"
#include "Comfunc.h"
#include "Resource.h"
#include "mblaunch.h"
#include "ExecDlg.h"
#include "PageDlg.h"
#include "BtnSetDlg.h"
#include <winuser.h>
#include <comdef.h>
#include <exdisp.h>
#include <shlwapi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define GetApp() ((CMblaunchApp*)AfxGetApp())

/////////////////////////////////////////////////////////////////////////////
// CExecDlg _CAO

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::CExecDlg
//\bhFRXgN^
//`    F  CExecDlg::CExecDlg(
//@@@@@@@F    [in]  CWnd* pParent  F eEBhENXւ̃|C^
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        FCDialogNXƂ
//------------------------------------------------------------------------------
//%ME_HEAD_END
CExecDlg::CExecDlg(CWnd* pParent /*=NULL*/)
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionDlgVertical() != 0 ) {
			m_blVertical = TRUE;
		}
		else {
			m_blVertical = FALSE;
		}

		if ( pApp->m_cIniInfo.loadOptionCustomButton() != 0 ) {
			char cTemp[256];
			char cPath[256];
			char cFullName[EXECFILEMAX];
			char cPathName[EXECFILEMAX];
			::GetModuleFileName( NULL, cFullName, EXECFILEMAX-1 );
			splitPath( cPathName, cFullName );

			pApp->m_cIniInfo.loadOptionCBPathName(cPath);
			for ( int i = 0; i < 4; i++ ) {
				sprintf( cTemp, "%s\\%s\\MBBTN%02ld.bmp", cPathName, cPath, i );
				if ( m_ciButtonImage[i].Load( cTemp ) == 0 ) {
					continue;
				}
				sprintf( cTemp, "%s\\%s\\MBBTN%02ld.jpg", cPathName, cPath, i );
				if ( m_ciButtonImage[i].Load( cTemp ) == 0 ) {
					continue;
				}
				if ( i > 1 ) {
					sprintf( cTemp, "%s\\%s\\MBBTN00.bmp", cPathName, cPath );
					if ( m_ciButtonImage[i].Load( cTemp ) == 0 ) {
						continue;
					}
					sprintf( cTemp, "%s\\%s\\MBBTN00.jpg", cPathName, cPath );
					if ( m_ciButtonImage[i].Load( cTemp ) == 0 ) {
						continue;
					}
				}
				//łt@CȂAJX^{^Off
				pApp->m_cIniInfo.saveOptionCustomButton(0);
				break;
			}
		}

		if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 0 ) {
			if ( m_blVertical != TRUE ) {
				CDialog(CExecDlg::IDD, pParent);
			}
			else {
				CDialog(CExecDlg::IDDT, pParent);
			}
		}
		else if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 2 ) {
			if ( m_blVertical != TRUE ) {
				CDialog(CExecDlg::IDS, pParent);
			}
			else {
				CDialog(CExecDlg::IDST, pParent);
			}
		}
		else {
			if ( m_blVertical != TRUE ) {
				CDialog(CExecDlg::IDM, pParent);
			}
			else {
				CDialog(CExecDlg::IDMT, pParent);
			}
		}
	}
	else {
		CDialog(CExecDlg::IDM, pParent);
		m_blVertical = FALSE;
	}

	//{{AFX_DATA_INIT(CExecDlg)
	//}}AFX_DATA_INIT

	//Xsۑp
	memset( m_cSpinData, 0x00, sizeof(m_cSpinData) );

	m_iAreaMax = 0;
	m_iNowSpin = 0;
	m_blDisp = FALSE;

	m_iEraseAfterRun = 0;
	m_iHideAfterRun = 0;
	m_iQuitAfterRun = 0;
	m_iMagnet = 0;
	m_iMagnetSize = 10;

	m_iButtonCount = EXEC_BUTTON_MAX;

	m_blHide = FALSE;
	m_iHideSize = 0;

	m_blDragFlg = FALSE;
	m_iFullDrag = 0;
	m_iAutoHide = 0;
	m_blPauseHide = FALSE;

	m_blCustomPage = FALSE;

	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 0 ) {
			if ( m_blVertical != TRUE ) {
				Create( CExecDlg::IDD, pParent );
			}
			else {
				Create( CExecDlg::IDDT, pParent );
			}
		}
		else if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 2 ) {
			if ( m_blVertical != TRUE ) {
				Create( CExecDlg::IDS, pParent );
			}
			else {
				Create( CExecDlg::IDST, pParent );
			}
		}
		else {
			if ( m_blVertical != TRUE ) {
				Create( CExecDlg::IDM, pParent );
			}
			else {
				Create( CExecDlg::IDMT, pParent );
			}
		}
	}
	else {
		Create( CExecDlg::IDM, pParent );
	}
}


void CExecDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExecDlg)
	DDX_Control(pDX, IDC_SPINNO, m_cSpinST);
	DDX_Control(pDX, IDC_PAGEBT, m_cPageBT);
	DDX_Control(pDX, IDC_ICONSPIN, m_Spin);
	//}}AFX_DATA_MAP
//{^ύXC
	DDX_Control(pDX, IDC_ICBUTTONZ, m_IconBtn[34]);
	DDX_Control(pDX, IDC_ICBUTTONY, m_IconBtn[33]);
	DDX_Control(pDX, IDC_ICBUTTONX, m_IconBtn[32]);
	DDX_Control(pDX, IDC_ICBUTTONW, m_IconBtn[31]);
	DDX_Control(pDX, IDC_ICBUTTONV, m_IconBtn[30]);
	DDX_Control(pDX, IDC_ICBUTTONU, m_IconBtn[29]);
	DDX_Control(pDX, IDC_ICBUTTONT, m_IconBtn[28]);
	DDX_Control(pDX, IDC_ICBUTTONS, m_IconBtn[27]);
	DDX_Control(pDX, IDC_ICBUTTONR, m_IconBtn[26]);
	DDX_Control(pDX, IDC_ICBUTTONQ, m_IconBtn[25]);
	DDX_Control(pDX, IDC_ICBUTTONP, m_IconBtn[24]);
	DDX_Control(pDX, IDC_ICBUTTONO, m_IconBtn[23]);
	DDX_Control(pDX, IDC_ICBUTTONN, m_IconBtn[22]);
	DDX_Control(pDX, IDC_ICBUTTONM, m_IconBtn[21]);
	DDX_Control(pDX, IDC_ICBUTTONL, m_IconBtn[20]);
	DDX_Control(pDX, IDC_ICBUTTONK, m_IconBtn[19]);
	DDX_Control(pDX, IDC_ICBUTTONJ, m_IconBtn[18]);
	DDX_Control(pDX, IDC_ICBUTTONI, m_IconBtn[17]);
	DDX_Control(pDX, IDC_ICBUTTONH, m_IconBtn[16]);
	DDX_Control(pDX, IDC_ICBUTTONG, m_IconBtn[15]);
	DDX_Control(pDX, IDC_ICBUTTONF, m_IconBtn[14]);
	DDX_Control(pDX, IDC_ICBUTTONE, m_IconBtn[13]);
	DDX_Control(pDX, IDC_ICBUTTOND, m_IconBtn[12]);
	DDX_Control(pDX, IDC_ICBUTTONC, m_IconBtn[11]);
	DDX_Control(pDX, IDC_ICBUTTONB, m_IconBtn[10]);
	DDX_Control(pDX, IDC_ICBUTTONA, m_IconBtn[9]);
	DDX_Control(pDX, IDC_ICBUTTON9, m_IconBtn[8]);
	DDX_Control(pDX, IDC_ICBUTTON8, m_IconBtn[7]);
	DDX_Control(pDX, IDC_ICBUTTON7, m_IconBtn[6]);
	DDX_Control(pDX, IDC_ICBUTTON6, m_IconBtn[5]);
	DDX_Control(pDX, IDC_ICBUTTON5, m_IconBtn[4]);
	DDX_Control(pDX, IDC_ICBUTTON4, m_IconBtn[3]);
	DDX_Control(pDX, IDC_ICBUTTON3, m_IconBtn[2]);
	DDX_Control(pDX, IDC_ICBUTTON2, m_IconBtn[1]);
	DDX_Control(pDX, IDC_ICBUTTON1, m_IconBtn[0]);
}


BEGIN_MESSAGE_MAP(CExecDlg, CDialog)
	//{{AFX_MSG_MAP(CExecDlg)
	ON_WM_DESTROY()
	ON_NOTIFY(UDN_DELTAPOS, IDC_ICONSPIN, OnDeltaposIconSpin)
	ON_WM_CLOSE()
	ON_WM_MOUSEWHEEL()
	ON_WM_RBUTTONDOWN()
	ON_WM_CREATE()
	ON_WM_WINDOWPOSCHANGING()
	ON_WM_NCLBUTTONDBLCLK()
	ON_WM_SYSCOMMAND()
	ON_WM_ACTIVATE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
	ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnNeedText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExecDlg bZ[W nh

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnInitDialog
//\bhF_CAÕCxgnh
//`    F  BOOL CExecDlg::OnInitDialog(
//              F  )
//^[l  FTRUE, sFALSE
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
BOOL CExecDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return FALSE;
	}

	if ( pApp->m_cIniInfo.loadOptionTransparent() != 0 ) {
		LONG lExStyle;
		lExStyle = ::GetWindowLong( m_hWnd, GWL_EXSTYLE );
		::SetWindowLong( m_hWnd, GWL_EXSTYLE, lExStyle | 0x80000 );
		SetAlpha(255);
	}

	if ( pApp->m_cIniInfo.loadOptionTopMost() != 0 ) {
		SetWindowPos( &CExecDlg::wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE );
	}

	int iRet = 0;
	UDACCEL udAccel;
	int iSpinNo = 0;
	char cTemp[EXECTMP10];
	CString csTemp;
	CString csTitle;
	char cTemp2[512];
	int i;
	CRect rect;
	CStatic* CStaticPtr;

	if ( loadOptionDispTask() == 1 ) {
		ModifyStyleEx( 0, WS_EX_APPWINDOW, SWP_NOMOVE );
	}

	::SystemParametersInfo( SPI_GETDRAGFULLWINDOWS, 0, &m_blDragFlg, 0 );
	m_iFullDrag = loadOptionFullDrag();

	m_iAutoHide = loadOptionAutoHide();

	memset( cTemp, 0x00, sizeof(cTemp) );

	if ( loadOptionFirstPageDisp() != 0 ) {
		iSpinNo = 1;
	}
	else {
		//Xs{^̓ǂݍ
		SpinLoad( cTemp );
		iSpinNo = atoi( cTemp );
	}

	if ( iSpinNo > m_iAreaMax ) {
		iSpinNo = m_iAreaMax;
	}
	else if ( iSpinNo <= 0 && m_iAreaMax > 0 ) {
		iSpinNo = 1;
	}

	//Xs{^̏ݒ
	if ( m_blVertical != TRUE ) {
		m_Spin.SetRange( m_iAreaMax - 1, 0 );
	}
	else {
		m_Spin.SetRange( 0, m_iAreaMax - 1 );
	}
	m_Spin.GetAccel( 1, &udAccel );
	udAccel.nInc = 1;
	m_Spin.SetAccel( 1, &udAccel );
	m_Spin.SetPos( iSpinNo-1 ) ;

	m_iNowSpin = iSpinNo - 1;

	if ( m_blCustomPage == FALSE ) {
		csTemp.Format( "%d", iSpinNo );
		m_cSpinST.SetWindowText( csTemp.GetBuffer(csTemp.GetLength()) );

		strcpy( m_cSpinData, csTemp.GetBuffer(csTemp.GetLength()) );

		csTemp.ReleaseBuffer();

		cTemp2[0] = '\0';
		pApp->m_cIniInfo.loadPageName( m_iNowSpin+1, cTemp2 );

		csTitle = APP_NAME;
		csTitle += DLG_CAP;
		csTitle += cTemp2;
		SetWindowText( csTitle );
	}
	else {
		m_cSpinST.SetWindowText( "-" );

		csTitle = APP_NAME;
		csTitle += DLG_CAP;
		csTitle += "[Custom]";
		SetWindowText( csTitle );
	}

	if ( loadOptionPageBtnDisp() != 0 ) {
		m_cPageBT.LoadBitmaps( IDB_BITMAP1, IDB_BITMAP2, NULL, NULL );
		m_cPageBT.SizeToContent();
		m_cPageBT.ModifyStyle( 0, WS_VISIBLE, 0 );
		m_cPageBT.EnableWindow( TRUE );
	}
	else {
		m_cPageBT.ModifyStyle( WS_VISIBLE, 0, 0 );
		m_cPageBT.EnableWindow( FALSE );
	}

	for ( i = 0; i < m_iButtonCount; i++ ) {
		m_IconBtn[i].GetWindowRect(&rect);
		m_IconBtn[i].ScreenToClient(rect);
		m_ttc.AddTool( &(m_IconBtn[i]), LPSTR_TEXTCALLBACK, &rect, i+1 );

		CStaticPtr = (CStatic*)GetDlgItem(m_IconBtn[i].m_lLabelID);
		if ( CStaticPtr != NULL ) {
			CStaticPtr->GetWindowRect(&rect);
			ScreenToClient(rect);
			m_ttc.AddTool(this, LPSTR_TEXTCALLBACK, &rect, i+1 );
		}
	}

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if ( pSysMenu != NULL ) {
		pSysMenu->AppendMenu( MF_SEPARATOR );

		if ( m_iAutoHide == 1 ) {
			pSysMenu->AppendMenu( MF_STRING, IDM_PAUSEHD, "èގBx~" );
		}

		pSysMenu->AppendMenu( MF_STRING, IDM_DLGHIDE, "݂B" );
	}

	return TRUE;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnDestroy
//\bhFfXgC̃Cxgnh
//`    F  void CExecDlg::OnDestroy(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::OnDestroy() 
{
	if ( m_iFullDrag == 1 ) {
		::SystemParametersInfo( SPI_SETDRAGFULLWINDOWS, m_blDragFlg, NULL, 0 );
	}

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		CRect tagRect;
		GetWindowRect( &tagRect );

		pApp->m_cIniInfo.saveOptionExecDlgX( tagRect.left );

		if ( m_blHide == TRUE ) {
			if ( IsMagnetUnderTask( tagRect ) == TRUE ) {
				if ( m_iHideSize != 0 ) {
					tagRect.top -= m_iHideSize;
				}
				else {
					tagRect.top -= 75;
				}
			}
		}
		pApp->m_cIniInfo.saveOptionExecDlgY( tagRect.top );

		pApp->m_pccExecDlg = NULL;

		for ( int i = 0; i < 4; i++ ) {
			m_ciButtonImage[i].ReleaseGDIPlus();
		}
	}

	//Xs{^݈̌ʒuhmht@Cɕۑ
	SpinSave();

	CDialog::OnDestroy();
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnDeltaposIconSpin
//\bhFXs{^̃NbN񐔎擾
//`    F  void CExecDlg::OnDeltaposIconSpin(
//@@@@@@@F    [in]  NMHDR* pNMHDR     :  NMHDR \
//@@@@@@@F    [out] LRESULT* pResult  :  R[obN֐̖߂l
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::OnDeltaposIconSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	int iSpin;

	memset( m_cSpinData, 0x00, sizeof(EXECTMP10) );
	m_Spin.UpdateData( TRUE );

	//Xs{^͉̓񐔂̎擾
	iSpin = pNMUpDown->iPos + pNMUpDown->iDelta;
	if ( iSpin > m_iAreaMax - 1 ) {
		iSpin = 0;
	}
	else if ( iSpin < 0 ) {
		iSpin = m_iAreaMax - 1;
	}

	setToggle( iSpin );

	*pResult = 0;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::IconRecFileRun
//\bhFACRɐݒ肳Ăt@Cs
//`    F  int CExecDlg::IconRecFileRun(
//@@@@@@@F    [in]  char pcRunFileName[]  : st@C
//              F  )
//^[l  F0, s-1
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CExecDlg::IconRecFileRun( char* pcRunFileName, char* cOption, int iShow )
{
	int iRet = 0;
	int iStartRet = 0;				//ExecStartp
	int iFileRet = 0;				//t@Cp
	int iExeType = 0;				//dwd^Cv߂l
	CString csFileName;				//t@C
	CString csFileBuff;				//t@C
	char* cAppFileName;				//t@C
	char cFName[FILELEN];			//t@Cobt@
	CFileStatus status;				//t@C݃`FbNp
	char cTempName[FILELEN] ;		//ƃobt@

	TRY {
		//
		memset( cFName, 0x00, sizeof(cFName) );
		memset( cTempName, 0x00, sizeof(cTempName) );

		//t@C̎擾
		csFileName = pcRunFileName;

		//t@Ce`FbN
		if ( csFileName.GetLength() == 0 ) {
			MessageBox( ERR_EXEC_MSG01, ERR_EXEC_TITLE01, MB_OK | MB_ICONEXCLAMATION ) ;
			return( ER_EXECDLG001 ) ;
		}

		//tpX̎擾
		cAppFileName = csFileName.GetBuffer( csFileName.GetLength() );

		//t@C`FbN
		if ( csFileName.GetLength() > EXECFILEMAX ) {
			if ( cAppFileName != NULL ) {
				csFileName.ReleaseBuffer();
				cAppFileName = NULL;
			}
			//t@Cꍇ
			return( ER_EXECDLG010 );
		}

		//ϐ̒u
		if ( dReplaceEnvParam( cTempName, cAppFileName ) < NO_ERR ) {
			if ( cAppFileName != NULL ) {
				csFileName.ReleaseBuffer();
				cAppFileName = NULL;
			}
			//NɎs
			return( ER_EXECDLG002 );
		}

		if ( cAppFileName != NULL ) {
			csFileName.ReleaseBuffer();
			cAppFileName = NULL;
		}

		//t@C̑݃`FbN
		if ( (iExeType = dCheckExecFileType( cTempName )) == ERR_GENERAL ) {
			//t@C݂Ȃ
			return( ER_EXECDLG003 );
		}
		else {
			//w蕶̂܂܃Rs[
			strcpy( cFName, cTempName );
		}

		//ϐ̒u
		if ( dReplaceEnvParam( cTempName, cOption ) < NO_ERR ) {
			//NɎs
			return( ER_EXECDLG002 );
		}
		else {
			strcpy( cOption, cTempName );
		}

		//AvP[Vs
		iStartRet = ExecStart( cFName, cOption, iShow );
		if ( iStartRet == ERR_EXEC_DLG + EC_APP_001 ) {				//AvP[V̋NɎs
			//NɎs
			return( ER_EXECDLG005 );
		}
	}
	CATCH( CMemoryException, e ) {
		//NɎs
		return( ER_EXECDLG002 );
	} END_CATCH

	return ( 0 );
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::SpinSave
//\bhFXs{^݈̌ʒuINIt@Cɕۑ
//`    F  int CExecDlg::SpinSave(
//              F  )
//^[l  F0, s-1
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CExecDlg::SpinSave()
{
	char cIniFileName[512];

	getIniFileName( cIniFileName );

	//Xs{^̕ۑs
	::WritePrivateProfileString( EX_SECTIONSPINNO, EX_ICONSPINNO, m_cSpinData, cIniFileName );

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		int i;
		for ( i = 0; i < m_iButtonCount; i++ ) {
			if ( m_IconBtn[i].m_iSpin != m_iNowSpin ) {
				pApp->m_cIniInfo.saveButtonPageNum( i, m_IconBtn[i].m_iSpin+1 );
			}
			else {
				pApp->m_cIniInfo.saveButtonPageNum( i, -1 );
			}
		}
	}

	return( 0 ) ;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::SpinLoad
//\bhFXs{^݈̌ʒuINIt@Cǂݍ
//`    F  int CExecDlg::SpinLoad(
//@@@@@@@F    [out] char* pcSpinNo   :   擾Xsԍ
//              F  )
//^[l  F0, s-1
//O        FȂ
//쐬N  F2000/11/30
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
int CExecDlg::SpinLoad( char* pcSpinNo )
{
	char cTemp[EXECTMP10];
	DWORD ProfileLen = 0;
	char cIniFileName[512];

	memset( cTemp, 0x00,sizeof(cTemp) ) ;

	getIniFileName( cIniFileName );

	//INIt@CXsԍ擾
	ProfileLen = ::GetPrivateProfileString( EX_SECTIONSPINNO, EX_ICONSPINNO, "", cTemp, EXECTMP10-1, cIniFileName );
	if ( ProfileLen == 0 ) {
		//ftHgłPԂ
		strcpy( pcSpinNo, "1" );
		return ( 0 ) ;
	}

	//擾XsNOԂ
	strcpy( pcSpinNo, cTemp );

	return ( 0 ) ;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::PostNcDestroy
//\bhFEBhEfXgC̃Cxgnh
//`    F  void CExecDlg::PostNcDestroy(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::PostNcDestroy() 
{
	CDialog::PostNcDestroy();

	delete this;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnOK
//\bhFOK{^̃Cxgnh
//`    F  void CExecDlg::OnOK(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::OnOK() 
{
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnClose
//\bhF_CAON[ỸCxgnh
//`    F  void CExecDlg::OnClose(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::OnClose()
{
	ShowWindow( SW_HIDE );
	m_blDisp = FALSE;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnCancel
//\bhFLZ̃Cxgnh
//`    F  void CExecDlg::OnCancel(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/11/29
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::OnCancel() 
{
	ShowWindow( SW_HIDE );
	m_blDisp = FALSE;
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::OnMouseWheel
//\bhF}EXzC[̃Cxgnh
//`    F  BOOL CExecDlg::OnMouseWheel(
//@@@@@@@F    [in]   UINT nFlags    :  }EX
//@@@@@@@F    [in]   short zDelta   :  ]
//@@@@@@@F    [in]   CPoint pt      :  J[\W
//              F  )
//^[l  F0ȊO=L, 0=
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
BOOL CExecDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	int iSpin;

	int i;
	for ( i = 0; i < m_iButtonCount; i++ ) {
		if ( m_IconBtn[i].OnMouseWheel(nFlags, zDelta, pt) == TRUE ) {
			return TRUE;
		}
	}

//	CRect  rcWindow;
	//EBhEʒu擾
//	GetWindowRect( rcWindow );

	//EBhEʒuƃ}EX|C^̔r
//	if( rcWindow.PtInRect( pt ) != FALSE ) {
		if ( zDelta < 0 ) {
			iSpin = m_iNowSpin;
			iSpin++;
		}
		else if ( zDelta > 0 ) {
			iSpin = m_iNowSpin;
			iSpin--;
		}

		if ( zDelta != 0 ) {
			if ( iSpin > m_iAreaMax - 1 ) {
				iSpin = 0;
			}
			else if ( iSpin < 0 ) {
				iSpin = m_iAreaMax - 1;
			}
			setToggle( iSpin );
			m_Spin.SetPos( iSpin );
		}
//	}

	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::setToggle
//\bhFgO̐ݒ
//`    F  void CExecDlg::setToggle(
//@@@@@@@F    [in]   int iSpin      :  Xsԍ
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::setToggle( int iSpin )
{
	char cTemp[512];
	CString csTitle;
	int i;

	if ( iSpin >= 0 && iSpin <= m_iAreaMax - 1 ) {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return;
		}

		m_iNowSpin = iSpin;
		//ACR`FW
		for ( i = 0; i < m_iButtonCount; i++ ) {
			m_IconBtn[i].ToggleChange( iSpin );
		}
		if ( pApp->m_cIniInfo.loadOptionNoAnime() == 0 ) {
			for ( i = 0; i < m_iButtonCount; i++ ) {
				m_IconBtn[i].UpdateWindow();
			}
//			Sleep(30);
			Sleep(20);
			for ( i = 0; i < m_iButtonCount; i++ ) {
				m_IconBtn[i].InvalidateRect(NULL);
				m_IconBtn[i].UpdateWindow();
			}
		}

		//x̐ݒ
		iSpin = iSpin + 1 ; 
		_itoa( iSpin, m_cSpinData, 10) ;
		//xɏ
		m_cSpinST.SetWindowText( m_cSpinData );

		pApp->m_cIniInfo.loadPageName( m_iNowSpin+1, cTemp );
		csTitle = APP_NAME;
		csTitle += DLG_CAP;
		csTitle += cTemp;
		SetWindowText( csTitle );
	}
}

//%ME_HEAD_BGN
//------------------------------------------------------------------------------
//\bh́FCExecDlg::PreSubclassWindow
//\bhF_CAOA^b`̏
//`    F  void CExecDlg::PreSubclassWindow(
//              F  )
//^[l  FȂ
//O        FȂ
//쐬N  F2000/12/01
//쐬Җ    FMacBS
//l        F
//------------------------------------------------------------------------------
//%ME_HEAD_END
void CExecDlg::PreSubclassWindow() 
{
	int i;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	m_iAreaMax = pApp->m_cIniInfo.loadOptionAreaMax();
	m_iEraseAfterRun = loadOptionEraseExecDlg();
	m_iHideAfterRun = loadOptionHideExecDlg();
	m_iQuitAfterRun = loadOptionQuitExecDlg();
	m_iMagnet = loadOptionMagnetExecDlg();
	m_iMagnetSize = loadOptionMagnetSize();

	for ( i = 0; i < m_iButtonCount; i++ ) {
		if ( m_IconBtn[i].AllocArea(m_iAreaMax) != 0 ) {
			return;
		}
	}

	CDialog::PreSubclassWindow();
}

void CExecDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
//	RECT Rect;
	CMenu cMenu;
	BOOL bRet = 0;
	CMenu* pPopup;
	char cTmp[256];
	char cTmp2[256];
	int i;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	//|bvAbvj[̓ǂݍ
	bRet = cMenu.LoadMenu( IDR_POPUPMENU ) ;
	if ( bRet == 0 ) {
		//j[ǂݍݎs
		return ;
	}

	//|bvAbvj[̎擾
	pPopup = cMenu.GetSubMenu( 1 ) ;
	if ( pPopup == NULL ) {
		//|bvAbv j[擾s
		return ;
	}

	CPoint cDot( point );
	ClientToScreen( &cDot );

	for ( i = 0; i < m_iAreaMax; i++ ) {
		pApp->m_cIniInfo.loadPageName( i+1, cTmp );
		dReplaceAmpasand( cTmp2, cTmp );
		if ( i < 10 || i % 10 != 0 ) {
			pPopup->InsertMenu( i, MF_BYPOSITION | MF_STRING | MF_ENABLED, i+100, _T(cTmp2) );
		}
		else if ( ::GetSystemMetrics(SM_CXSCREEN) - cDot.x > 460 ) {
			pPopup->InsertMenu( i, MF_MENUBARBREAK | MF_BYPOSITION | MF_STRING | MF_ENABLED, i+100, _T(cTmp2) );
		}
		else {
			pPopup->InsertMenu( i, MF_BYPOSITION | MF_STRING | MF_ENABLED, i+100, _T(cTmp2) );
		}
	}

	if ( m_iAreaMax > 0 ) {
		if ( (i % 10 > 5 || i % 10 == 0) && ::GetSystemMetrics(SM_CXSCREEN) - cDot.x > 460 ) {
			pPopup->InsertMenu( i, MF_MENUBARBREAK | MF_BYPOSITION | MF_SEPARATOR | MF_ENABLED );
		}
		else {
			pPopup->InsertMenu( i, MF_BYPOSITION | MF_SEPARATOR | MF_ENABLED );
		}
	}

	if ( ::GetSystemMetrics(SM_CXSCREEN) - cDot.x > 460 ) {
		pPopup->TrackPopupMenu( TPM_LEFTALIGN | TPM_LEFTBUTTON, cDot.x, cDot.y, this );
	}
	else {
		pPopup->TrackPopupMenu( TPM_CENTERALIGN | TPM_LEFTBUTTON, cDot.x, cDot.y, this );
	}

	CDialog::OnRButtonDown(nFlags, point) ;
}

BOOL CExecDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	int iSpin;
	char cTemp[256];

	TRY {
		CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
		if ( pApp == NULL ) {
			return FALSE;
		}

		if ( HIWORD(wParam) == 0 ) {
			if ( LOWORD(wParam) == ID_PAGENAME ) {
				if ( m_iNowSpin >= 0 ) {
					CPageDlg cPageDlg;
					cPageDlg.m_iPageNo = m_iNowSpin + 1;
					pApp->m_cIniInfo.loadPageName( m_iNowSpin+1, cTemp );
					cPageDlg.m_lPageNoDisp = pApp->m_cIniInfo.loadPageNoDisp( m_iNowSpin+1 );
					cPageDlg.m_csPageName = cTemp;
					if ( cPageDlg.DoModal() == IDOK ) {
						pApp->m_cIniInfo.savePageName( m_iNowSpin+1, cPageDlg.m_csPageName.GetBuffer(cPageDlg.m_csPageName.GetLength()+1) );
						cPageDlg.m_csPageName.ReleaseBuffer();
						pApp->m_cIniInfo.savePageNoDisp( m_iNowSpin+1, cPageDlg.m_lPageNoDisp );
						setToggle( m_iNowSpin );
						m_Spin.SetPos( m_iNowSpin );
					}
				}
			}
			else if ( LOWORD(wParam) == ID_DLGCLOSE ) {
				ShowWindow( SW_HIDE );
				m_blDisp = FALSE;
			}
			else if ( LOWORD(wParam) == ID_DLGSEARCH ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnAppSearch();
				}
			}
			else if ( LOWORD(wParam) == ID_PAGE_EDIT ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnPageEdit();
				}
			}
			else if ( LOWORD(wParam) == ID_SYS_CTLPANEL ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnSysCtlpanel();
				}
			}
			else if ( LOWORD(wParam) == ID_SYS_DISPPROP ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnSysDispprop();
				}
			}
			else if ( LOWORD(wParam) == ID_SYS_SCRSAVER ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnSysScrsaver();
				}
			}
			else if ( LOWORD(wParam) == ID_SYS_RCTDEL ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnSysRctdel();
				}
			}
			else if ( LOWORD(wParam) == ID_SYS_TRASHDEL ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnSysTrashdel();
				}
			}
			else if ( LOWORD(wParam) == ID_SYS_WINEXIT ) {
				if ( pApp != NULL ) {
					pApp->m_pccMainFrame->OnSysWinexit();
				}
			}
//Add 2004.10.31 y[W{^̒ǉ
			else if ( LOWORD(wParam) == IDC_PAGEBT ) {
				CRect ccRect;
				m_cPageBT.GetWindowRect( &ccRect );
				ccRect.NormalizeRect();
				ScreenToClient( &ccRect );
				OnRButtonDown( 0, ccRect.CenterPoint() );
			}
//{^ύXC
			else if ( LOWORD(wParam) == IDC_ICBUTTON1 ||
					  LOWORD(wParam) == IDC_ICBUTTON2 ||
					  LOWORD(wParam) == IDC_ICBUTTON3 ||
					  LOWORD(wParam) == IDC_ICBUTTON4 ||
					  LOWORD(wParam) == IDC_ICBUTTON5 ||
					  LOWORD(wParam) == IDC_ICBUTTON6 ||
					  LOWORD(wParam) == IDC_ICBUTTON7 ||
					  LOWORD(wParam) == IDC_ICBUTTON8 ||
					  LOWORD(wParam) == IDC_ICBUTTON9 ||
					  LOWORD(wParam) == IDC_ICBUTTONA ||
					  LOWORD(wParam) == IDC_ICBUTTONB ||
					  LOWORD(wParam) == IDC_ICBUTTONC ||
					  LOWORD(wParam) == IDC_ICBUTTOND ||
					  LOWORD(wParam) == IDC_ICBUTTONE ||
					  LOWORD(wParam) == IDC_ICBUTTONF ||
					  LOWORD(wParam) == IDC_ICBUTTONG ||
					  LOWORD(wParam) == IDC_ICBUTTONH ||
					  LOWORD(wParam) == IDC_ICBUTTONI ||
					  LOWORD(wParam) == IDC_ICBUTTONJ ||
					  LOWORD(wParam) == IDC_ICBUTTONK ||
					  LOWORD(wParam) == IDC_ICBUTTONL ||
					  LOWORD(wParam) == IDC_ICBUTTONM ||
					  LOWORD(wParam) == IDC_ICBUTTONN ||
					  LOWORD(wParam) == IDC_ICBUTTONO ||
					  LOWORD(wParam) == IDC_ICBUTTONP ||
					  LOWORD(wParam) == IDC_ICBUTTONQ ||
					  LOWORD(wParam) == IDC_ICBUTTONR ||
					  LOWORD(wParam) == IDC_ICBUTTONS ||
					  LOWORD(wParam) == IDC_ICBUTTONT ||
					  LOWORD(wParam) == IDC_ICBUTTONU ||
					  LOWORD(wParam) == IDC_ICBUTTONV ||
					  LOWORD(wParam) == IDC_ICBUTTONW ||
					  LOWORD(wParam) == IDC_ICBUTTONX ||
					  LOWORD(wParam) == IDC_ICBUTTONY ||
					  LOWORD(wParam) == IDC_ICBUTTONZ ) {
				return CDialog::OnCommand(wParam, lParam);
			}
			else if ( LOWORD(wParam) >= 100 ) {
				iSpin = LOWORD(wParam) - 100;

				if ( iSpin > m_iAreaMax - 1 ) {
					iSpin = 0;
				}
				else if ( iSpin < 0 ) {
					iSpin = m_iAreaMax - 1;
				}
				setToggle( iSpin );
				m_Spin.SetPos( iSpin );
			}
			else {
				return CDialog::OnCommand(wParam, lParam);
			}
			return FALSE;
		}
		else {
			return CDialog::OnCommand(wParam, lParam);
		}
	}
	CATCH( CMemoryException, e ) {
		return FALSE;
	} END_CATCH
}

int CExecDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if ( CDialog::OnCreate(lpCreateStruct) == -1 ) {
		return -1;
	}

	if ( !m_ttc.Create(this, TTS_ALWAYSTIP) ) {
		return -1;
	}
	m_ttc.SetMaxTipWidth(384);
	m_ttc.Activate(TRUE);

	return 0;
}


BOOL CExecDlg::PreTranslateMessage(MSG* pMsg) 
{
	m_ttc.RelayEvent(pMsg);

	const UINT PAGEUPKEY   = 0x21;
	const UINT PAGEDNKEY   = 0x22;

	int iSpin;
	int iChange = 0;
	BOOL blSkip = FALSE;
	BOOL blPageMode = FALSE;

	if ( pMsg->message == WM_KEYDOWN ) {
		if ( pMsg->wParam == PAGEDNKEY ) {
			iChange = 5;
			blPageMode = TRUE;
		}
		else if ( pMsg->wParam == PAGEUPKEY ) {
			iChange = -5;
			blPageMode = TRUE;
		}
		else if ( pMsg->wParam == VK_DOWN ) {
			if ( m_blVertical != TRUE ) {
				iChange = 1;
				blSkip = TRUE;
			}
		}
		else if ( pMsg->wParam == VK_UP ) {
			if ( m_blVertical != TRUE ) {
				iChange = -1;
				blSkip = TRUE;
			}
		}
		else if ( pMsg->wParam == VK_RIGHT ) {
			if ( m_blVertical == TRUE ) {
				iChange = 1;
				blSkip = TRUE;
			}
		}
		else if ( pMsg->wParam == VK_LEFT ) {
			if ( m_blVertical == TRUE ) {
				iChange = -1;
				blSkip = TRUE;
			}
		}
		else if ( pMsg->wParam == VK_HOME ) {
			iChange = 0 - m_iNowSpin;
		}
		else if ( pMsg->wParam == VK_END ) {
			iChange = m_iAreaMax - 1 - m_iNowSpin;
		}
		else if ( pMsg->wParam == VK_RETURN ) {
			pMsg->wParam = VK_SPACE;
		}

		if ( iChange != 0 ) {
			iSpin = m_iNowSpin + iChange;
			if ( iSpin > m_iAreaMax - 1 ) {
				if ( blPageMode == TRUE ) {
					iSpin = m_iAreaMax - 1;
				}
				else {
					iSpin -= m_iAreaMax;
				}
			}
			else if ( iSpin < 0 ) {
				if ( blPageMode == TRUE ) {
					iSpin = 0;
				}
				else {
					iSpin += m_iAreaMax;
				}
			}
			if ( iSpin != m_iNowSpin ) {
				setToggle( iSpin );
				m_Spin.SetPos( iSpin );
			}
		}
	}
	else if ( pMsg->message == WM_SYSKEYDOWN ) {
		if ( pMsg->wParam == VK_LEFT ) {
			iChange = -1;
			blSkip = TRUE;
		}
		else if ( pMsg->wParam == VK_RIGHT ) {
			iChange = 1;
			blSkip = TRUE;
		}

		if ( iChange != 0 ) {
			iSpin = m_iNowSpin + iChange;
			if ( iSpin > m_iAreaMax - 1 ) {
				if ( blPageMode == TRUE ) {
					iSpin = m_iAreaMax - 1;
				}
				else {
					iSpin -= m_iAreaMax;
				}
			}
			else if ( iSpin < 0 ) {
				if ( blPageMode == TRUE ) {
					iSpin = 0;
				}
				else {
					iSpin += m_iAreaMax;
				}
			}
			if ( iSpin != m_iNowSpin ) {
				setToggle( iSpin );
				m_Spin.SetPos( iSpin );
			}
		}
	}
	else if ( pMsg->message == WM_KEYUP ) {
		if ( pMsg->wParam == VK_RETURN ) {
			pMsg->wParam = VK_SPACE;
		}
	}

	if ( blSkip != TRUE ) {
		return CDialog::PreTranslateMessage(pMsg);
	}
	else {
		return TRUE;
	}
}

BOOL CExecDlg::OnNeedText(UINT nId, NMHDR* pNMHdr, LRESULT* pResult)
{
	BOOL blOnlyLong;

	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp != NULL ) {
		if ( pApp->m_cIniInfo.loadOptionDispTool() != 0 ) {
			blOnlyLong = FALSE;
		}
		else {
			if ( pApp->m_cIniInfo.loadOptionExecDlgSmall() == 0 ) {
				blOnlyLong = TRUE;
			}
			else {
				return TRUE;
			}
		}
	}
	else {
		return TRUE;
	}

	TOOLTIPTEXT* pTTT = (TOOLTIPTEXT*)pNMHdr;
	UINT nID =pNMHdr->idFrom;
	CString csTemp;

	if ( nID >= 1 && nID <= (UINT)m_iButtonCount ) {
		csTemp = m_IconBtn[nID-1].m_csTitle[m_IconBtn[nID-1].m_iSpin];
	}
	else {
		return TRUE;
	}

	if ( blOnlyLong != FALSE ) {
		if ( csTemp.GetLength() <= EXEC_TITLE_MAX ) {
			return TRUE;
		}
	}
	::lstrcpy( pTTT->szText, csTemp );

	return TRUE;
}

int CExecDlg::ChangeButtonCount( int iButtonCount )
{
	CRect ccRect;
	CRect ccRect2;
	CStatic* CStaticPtr;
	int i;
	int iOffset;

	if ( iButtonCount < 1 || iButtonCount > EXEC_BUTTON_MAX ) {
		return -1;
	}

	//{^\
	for ( i = 0; i < iButtonCount-1; i++ ) {
		m_IconBtn[i].ModifyStyle( 0, WS_VISIBLE, 0 );
		m_IconBtn[i].EnableWindow( TRUE );
		CStaticPtr = (CStatic*)GetDlgItem(m_IconBtn[i].m_lLabelID);
		if ( CStaticPtr != NULL ) {
			CStaticPtr->ModifyStyle( 0, WS_VISIBLE, 0 );
			CStaticPtr->EnableWindow( TRUE );
		}
	}

	if ( iButtonCount < EXEC_BUTTON_MAX ) {

		//{^\
		for ( i = iButtonCount; i < EXEC_BUTTON_MAX; i++ ) {
			m_IconBtn[i].ModifyStyle( WS_VISIBLE, 0, 0 );
			m_IconBtn[i].EnableWindow( FALSE );
			CStaticPtr = (CStatic*)GetDlgItem(m_IconBtn[i].m_lLabelID);
			if ( CStaticPtr != NULL ) {
				CStaticPtr->ModifyStyle( WS_VISIBLE, 0, 0 );
				CStaticPtr->EnableWindow( FALSE );
			}
		}

		//ŉE[̃{^ʒu擾
		m_IconBtn[EXEC_BUTTON_MAX-1].GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		ScreenToClient( &ccRect );

		//\ŉE[̃{^ʒu擾
		m_IconBtn[iButtonCount-1].GetWindowRect( &ccRect2 );
		ccRect2.NormalizeRect();
		ScreenToClient( &ccRect2 );

		if ( m_blVertical != TRUE ) {
			iOffset = ccRect.left - ccRect2.left;
		}
		else {
			iOffset = ccRect.top - ccRect2.top;
		}

		//y[WXsʒu̕ύX
		m_Spin.GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		ScreenToClient( &ccRect );
		if ( m_blVertical != TRUE ) {
			ccRect.OffsetRect( iOffset*(-1), 0 );
		}
		else {
			ccRect.OffsetRect( 0, iOffset*(-1) );
		}
		m_Spin.MoveWindow( &ccRect, FALSE );

		//y[Wԍʒu̕ύX
		m_cSpinST.GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		ScreenToClient( &ccRect );
		if ( m_blVertical != TRUE ) {
			ccRect.OffsetRect( iOffset*(-1), 0 );
		}
		else {
			ccRect.OffsetRect( 0, iOffset*(-1) );
		}
		m_cSpinST.MoveWindow( &ccRect, FALSE );

//2004.10.30
		//y[W{^ʒu̕ύX
		m_cPageBT.GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		ScreenToClient( &ccRect );
		if ( m_blVertical != TRUE ) {
			ccRect.OffsetRect( iOffset*(-1), 0 );
		}
		else {
			ccRect.OffsetRect( 0, iOffset*(-1) );
		}
		m_cPageBT.MoveWindow( &ccRect, FALSE );

		//_CAOTCY̕ύX
		GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		ScreenToClient( &ccRect );
		if ( m_blVertical != TRUE ) {
			ccRect.right -= iOffset;
		}
		else {
			ccRect.bottom -= iOffset;
		}
		ClientToScreen( &ccRect );
		MoveWindow( &ccRect, FALSE );
	}

	m_iButtonCount = iButtonCount;

	return 0;
}

void CExecDlg::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos) 
{
	long lX;
	long lY;

	if ( lpwndpos == NULL || m_iMagnet == 0 ) {
		CDialog::OnWindowPosChanging(lpwndpos);
		return;
	}

	CRect ccRectOrg;
	BOOL blFlg;

	blFlg = FALSE;

	lX = lpwndpos->x;
	lY = lpwndpos->y;

	long lScreenX = ::GetSystemMetrics(SM_CXSCREEN);
	long lScreenY = ::GetSystemMetrics(SM_CYSCREEN);

	long lOfsTop = 0;
	long lOfsBottom = lScreenY;
	long lOfsLeft = 0;
	long lOfsRight = lScreenX;

	const char *pszTaskBar="Shell_TrayWnd";

	HWND hWnd = ::FindWindow( pszTaskBar, NULL );
	if ( hWnd != NULL ) {
		RECT RectTask;
		::GetWindowRect( hWnd, &RectTask );
		//
		if ( RectTask.left <= 0 && RectTask.right >= lScreenX && RectTask.bottom >= lScreenY ) {
			lOfsBottom = RectTask.top;
		}
		//
		else if ( RectTask.left <= 0 && RectTask.right >= lScreenX ) {
			lOfsTop = RectTask.bottom;
		}
		//
		else if ( RectTask.left <= 0 && RectTask.bottom >= lScreenY ) {
			lOfsLeft = RectTask.right;
		}
		//E
		else if ( RectTask.right >= lScreenX && RectTask.bottom >= lScreenY ) {
			lOfsRight = RectTask.left;
		}
	}

	GetWindowRect( &ccRectOrg );

	if ( labs(lX-lOfsLeft) <= m_iMagnetSize && lX != lOfsLeft ) {
		if ( lX + ccRectOrg.Width() != lOfsRight ) {
			lX = lOfsLeft;
			blFlg = TRUE;
		}
	}
	else if ( labs(lX + ccRectOrg.Width() - lOfsRight) <= m_iMagnetSize ) {
		if ( lX != lOfsLeft ) {
			lX = lOfsRight - ccRectOrg.Width();
			blFlg = TRUE;
		}
	}

	if ( labs(lY-lOfsTop) <= m_iMagnetSize && lY != lOfsTop ) {
		lY = lOfsTop;
		blFlg = TRUE;
	}
	else if ( labs(lY + ccRectOrg.Height() - lOfsBottom) <= m_iMagnetSize ) {
		lY = lOfsBottom - ccRectOrg.Height();
		blFlg = TRUE;
	}

	if ( blFlg == TRUE ) {
		lpwndpos->x = lX;
		lpwndpos->y = lY;
	}

	CDialog::OnWindowPosChanging(lpwndpos);
}

void CExecDlg::ChangeDialogStyle( BOOL blDisp )
{
	CRect ccRect;
	CRect ccRectClient;

	if ( blDisp == TRUE ) {
		if ( m_blHide == FALSE ) {
			return;
		}

		//_CAOTCY̕ύX
		GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		if ( IsMagnetUnderTask( ccRect ) == TRUE ) {
			if ( m_iHideSize != 0 ) {
				ccRect.top -= m_iHideSize;
			}
			else {
				ccRect.top -= 75;
			}
		}
		else {
			if ( m_iHideSize != 0 ) {
				ccRect.bottom += m_iHideSize;
			}
			else {
				ccRect.bottom += 75;
			}
		}
		MoveWindow( &ccRect, TRUE );

		setToggle( m_iNowSpin );

		CMenu* pSysMenu = GetSystemMenu( FALSE );
		if ( pSysMenu != NULL ) {
			pSysMenu->ModifyMenu( IDM_DLGHIDE, MF_BYCOMMAND | MF_STRING, IDM_DLGHIDE, "݂B" );
		}

		m_blHide = FALSE;
	}
	else {
		if ( m_blHide == TRUE ) {
			return;
		}

		//_CAOTCY̕ύX
		GetWindowRect( &ccRect );
		ccRect.NormalizeRect();
		GetClientRect( &ccRectClient );
		ccRectClient.NormalizeRect();
		if ( IsMagnetUnderTask( ccRect ) == TRUE ) {
			ccRect.top += ccRectClient.bottom - ccRectClient.top + 1;
		}
		else {
			ccRect.bottom -= ccRectClient.bottom - ccRectClient.top + 1;
		}
		m_iHideSize = ccRectClient.bottom - ccRectClient.top + 1;
		MoveWindow( &ccRect, TRUE );

		CMenu* pSysMenu = GetSystemMenu( FALSE );
		if ( pSysMenu != NULL ) {
			pSysMenu->ModifyMenu( IDM_DLGHIDE, MF_BYCOMMAND | MF_STRING, IDM_DLGHIDE, "݂\" );
		}

		m_blHide = TRUE;
	}

	return;
}

void CExecDlg::OnNcLButtonDblClk(UINT nHitTest, CPoint point) 
{
	BOOL blDisp;

	if ( m_blHide == FALSE ) {
		blDisp = FALSE;
	}
	else {
		blDisp = TRUE;
	}

	ChangeDialogStyle( blDisp );

	CDialog::OnNcLButtonDblClk(nHitTest, point);
}

BOOL CExecDlg::IsMagnetUnderTask( CRect& ccRect )
{
	if ( m_iMagnet != 0 ) {
		const char *pszTaskBar="Shell_TrayWnd";
		HWND hWnd = ::FindWindow( pszTaskBar, NULL );
		if ( hWnd != NULL ) {
			RECT RectTask;
			::GetWindowRect( hWnd, &RectTask );
			//ɂ^XNo[ɂĂ鎞
			if ( labs(RectTask.top - ccRect.bottom) == 0 ) {
				return TRUE;
			}
			else {
				long lScreenX = ::GetSystemMetrics(SM_CXSCREEN);
				long lScreenY = ::GetSystemMetrics(SM_CYSCREEN);
				//^XNo[ȊOŖ[Ȃ
				if ( (RectTask.left > 0 || RectTask.right < lScreenX || RectTask.bottom < lScreenY) &&
					 labs(lScreenY - ccRect.bottom) == 0 ) {
					return TRUE;
				}
				else {
					return FALSE;
				}
			}
		}
		else {
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
}

void CExecDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	if ((nID & 0xFFF0) == IDM_DLGHIDE ) {
		BOOL blDisp;

		if ( m_blHide == FALSE ) {
			blDisp = FALSE;
		}
		else {
			blDisp = TRUE;
		}

		ChangeDialogStyle( blDisp );
	}
	else if ((nID & 0xFFF0) == IDM_PAUSEHD ) {
		CMenu* pSysMenu = GetSystemMenu( FALSE );
		if ( m_blPauseHide == FALSE ) {
			m_blPauseHide = TRUE;
			if ( pSysMenu != NULL ) {
				pSysMenu->ModifyMenu( IDM_PAUSEHD, MF_BYCOMMAND | MF_STRING, IDM_PAUSEHD, "èގBĊJ" );
			}
		}
		else {
			m_blPauseHide = FALSE;
			if ( pSysMenu != NULL ) {
				pSysMenu->ModifyMenu( IDM_PAUSEHD, MF_BYCOMMAND | MF_STRING, IDM_PAUSEHD, "èގBx~" );
			}
		}
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CExecDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
	CMblaunchApp* pApp = (CMblaunchApp*)AfxGetApp();
	if ( pApp == NULL ) {
		return;
	}

	if ( nState == WA_INACTIVE ) {
		if ( m_iFullDrag == 1 ) {
			::SystemParametersInfo( SPI_SETDRAGFULLWINDOWS, m_blDragFlg, NULL, 0 );
		}
		if ( m_iAutoHide == 1 && m_blPauseHide == FALSE ) {
			ChangeDialogStyle( FALSE );
		}
		if ( pApp->m_cIniInfo.loadOptionTransparent() != 0 ) {
			SetAlpha(155);
		}
	}
	else {
		::SystemParametersInfo( SPI_GETDRAGFULLWINDOWS, 0, &m_blDragFlg, 0 );
		if ( m_iFullDrag == 1 ) {
			::SystemParametersInfo( SPI_SETDRAGFULLWINDOWS, TRUE, NULL, 0 );
		}
		if ( m_iAutoHide == 1 ) {
			ChangeDialogStyle( TRUE );
		}
		if ( pApp->m_cIniInfo.loadOptionTransparent() != 0 ) {
			SetAlpha(255);
		}
	}

	CDialog::OnActivate(nState, pWndOther, bMinimized);
}

int CExecDlg::SetAlpha( int n )
{
	HMODULE hDLL;
	typedef DWORD (WINAPI *PFUNC)(HWND,DWORD,BYTE,DWORD);
	PFUNC pFunc;

	hDLL = ::LoadLibrary("user32");
	if ( hDLL == NULL ) {
		return( 0 );
	}
	pFunc = (PFUNC)::GetProcAddress( hDLL, "SetLayeredWindowAttributes" );
	if ( pFunc != NULL ) {
		pFunc( m_hWnd, 0, n, 2 );
	}
	::FreeLibrary(hDLL);

	return 0;
}
